#INCLUDE "matr462.ch"
#INCLUDE "Protheus.Ch"
#define TT	Chr(254)+Chr(254)
/*


Ŀ
Funo     MATR462   Autor Rodrigo de A Sartorio   Data  02.08.04 
Ĵ
Descrio  Relatorios Produtos Controlados DECRETO 3665               
Ĵ
Parametros Nenhum                                                     
Ĵ
Retorno    Nenhum                                                     
Ĵ
 Uso       Generico                                                   
ٱ




Ŀ
Descrio  PLANO DE MELHORIA CONTINUA        Programa    MATR462.PRW 
Ĵ
ITEM PMC   Responsavel               Data       	|BOPS             
Ĵ
      01   Ricardo Berti             14/08/2006	| 00000097557     
      02   Ricardo Berti             14/08/2006	| 00000097557     
      03                                       	|                 
      04                                       	|                 
      05                                       	|                 
      06                                       	|                 
      07                                       	|                 
      08   Ricardo Berti             14/08/2006	| 00000097557     
      09   Ricardo Berti             14/08/2006	| 00000097557     
      10   Ricardo Berti             14/08/2006	| 00000097557     
ٱ


*/
Function MATR462()
Local wnrel
Local titulo	:=STR0001 //"Mapas de Produtos Controlados"
Local cDesc1	:=STR0002 //"Emisso dos mapas civil de compra, venda e mapa do Exercito"
Local cDesc2	:=STR0003 //"de produtos controlados"
Local cDesc3	:=""
Local cString	:="SB1"
Local cNomeProg	:="MATR462"
Local Tamanho	:="G"
Local cPerg		:="MTR462"
Private aReturn	:={STR0004,1,STR0005,2,2,1,"",1} //"Zebrado"###"Administracao"
Private nLastKey:=0

//Ŀ
// Ajusta as Perguntas do SX1				                     
//
AjustaPerg(cPerg)

//Ŀ
// Envia controle para a funcao SETPRINT                        
//
wnrel:=SetPrint(cString,cNomeProg,cPerg,@titulo,cDesc1,cDesc2,cDesc3,.F.,,.T.,Tamanho)

If nLastKey==27
	Return .T.
Endif
SetDefault(aReturn,cString)
If nLastKey==27
	Return .T.
Endif
//Ŀ
// Verifica as perguntas selecionadas                           
//
//Ŀ
// Variaveis utilizadas para parametros                         
// mv_par01     // De  Produto                                  
// mv_par02     // Ate Produto                                  
// mv_par03     // De  Armazem                                  
// mv_par04     // Ate Armazem                                  
// mv_par05     // De  Grupo                                    
// mv_par06     // Ate Grupo                                    
// mv_par07     // De  Tipo                                     
// mv_par08     // Ate Tipo                                     
// mv_par09     // Trimestre                                    
// mv_par10     // Imprime Mapa Civil Compra  1 - Sim 2 - Nao   
// mv_par11     // Imprime Mapa Civil Venda   1 - Sim 2 - Nao   
// mv_par12     // Imprime Mapa Exercito      1 - Sim 2 - Nao   
// mv_par13     // Informe a RM		       (Regiao Militar)  
// mv_par14     // Informe o CR		       (Certif.Registro) 
// mv_par15     // CR Valido ate'                               
//
Pergunte(cPerg,.F.)

If mv_par10 == 1 .Or. mv_par11 == 1 .Or. mv_par12 == 1
	RptStatus({|lEnd| R462Imp(@lEnd,wnRel,cString,Tamanho)},titulo)
Endif

If aReturn[5]==1
	Set Printer To
	dbCommitAll()
	OurSpool(wnrel)
Endif
MS_FLUSH()
Return (NIL)

/*


Ŀ
Funo     R462Imp   Autor Rodrigo de A Sartorio   Data  02.08.04 
Ĵ
Descrio  Impressao do relatorio                                     
Ĵ
Parametros ExpL1 = Variavel p/ controle de interrupcao pelo usuario   
           ExpC1 = Codigo do relatorio                                
           ExpC2 = Alias do arquivo                                   
           ExpC3 = Tamanho do relatorio			                      
Ĵ
Retorno    Nenhum                                                     
Ĵ
 Uso       MATR462                                                    
ٱ


*/
Static Function R462Imp(lEnd,wnRel,cString,Tamanho)
Local aArqTemp	:={}
Local aTam    	:={}
Local cArqTemp1	:="",cIndTemp1:=""
Local cArqTemp2	:="",cIndTemp2:="",cIndTemp3:=""
Local cArqTemp3	:="",cIndTemp4:=""
Local dDataIni	:=dDataBase
Local dDataFim	:=dDataBase
Local aMes		:={1,4,7,10} // Meses que iniciam trimestre
Local aMesOrd	:={STR0006,STR0007,STR0008,STR0009} // Ordinal dos trimestres //"PRIMEIRO"###"SEGUNDO"###"TERCEIRO"###"QUARTO"
Local lFirst 	:= .T.
Local nLinMax	:=0
Local aSaldo	:={}
Local nSaldoIni	:=0
Local nTamCPro	:=TamSX3("B1_COD")[1]
Local nTamForn	:=TamSX3("D1_FORNECE")[1]

// Calculo da data inicial e final
dDataIni := CTOD("01/"+Str(aMes[mv_par09],2,0)+"/"+Str(Year(dDataBase),4,0),"ddmmyyyy")
dDataFim := LastDay(CTOD("01/"+Str(aMes[mv_par09]+2,2,0)+"/"+Str(Year(dDataBase),4,0),"ddmmyyyy"))

// Montagem dos arquivos de trabalhos
// TOTCOM - Totalizador do mapa de compras
AADD(aArqTemp,{"PRODUTO"	,"C",nTamCPro,0})
aTam:=TamSX3("B1_DESC")
AADD(aArqTemp,{"DESCRIPRO"	,"C",aTam[1],aTam[2]})
aTam:=TamSX3("B2_QFIM")
AADD(aArqTemp,{"SALDOANT"	,"N",16,aTam[2]})
AADD(aArqTemp,{"COMPRAS"	,"N",16,aTam[2]})
AADD(aArqTemp,{"VENDAS"  	,"N",16,aTam[2]})
AADD(aArqTemp,{"CONSUMO" 	,"N",16,aTam[2]})
AADD(aArqTemp,{"ESTOQFIM"	,"N",16,aTam[2]})
aTam:=TamSX3("B1_UM")
AADD(aArqTemp,{"UM"			,"C",aTam[1],aTam[2]})
aTam:=TamSX3("B1_SEGUM")
AADD(aArqTemp,{"SEGUM" 		,"C",aTam[1],aTam[2]})
cArqTemp1:=CriaTrab(aArqTemp)
cIndTemp1:=Substr(CriaTrab(NIL,.F.),1,7)+"1"
dbUseArea(.T.,nil,cArqTemp1,"TOTCOM",.T.,.F.)
IndRegua("TOTCOM",cIndTemp1,"PRODUTO")
Set Cursor Off
DbClearIndex()
DbSetIndex(cIndTemp1+OrdBagExt())

// ITECOM - Item do mapa de compras
aArqTemp :={}
aTam:=TamSX3("B1_DESC")
AADD(aArqTemp,{"DESCRIPRO"	,"C",aTam[1],aTam[2]})
AADD(aArqTemp,{"DTDIGIT"	,"D",8,0})
aTam:=TamSX3("D1_FORNECE")
AADD(aArqTemp,{"FORNECEDOR"	,"C",aTam[1],aTam[2]})
aTam:=TamSX3("D1_LOJA")
AADD(aArqTemp,{"LOJA"		,"C"  ,aTam[1],aTam[2]})
aTam:=TamSX3("A2_NOME")
AADD(aArqTemp,{"DESCRIFOR"	,"C",aTam[1],aTam[2]})
aTam:=TamSX3("A2_END")
AADD(aArqTemp,{"ADRESS"  	,"C",aTam[1],aTam[2]})
aTam:=TamSX3("A2_CEP")
AADD(aArqTemp,{"CEP"       	,"C",aTam[1],aTam[2]})
aTam:=TamSX3("A2_MUN")
AADD(aArqTemp,{"MUNICIPIO" 	,"C",aTam[1],aTam[2]})
aTam:=TamSX3("A2_EST")
AADD(aArqTemp,{"UF"			,"C",aTam[1],aTam[2]})
aTam:=TamSX3("D1_DOC")
AADD(aArqTemp,{"DOCUMENTO" ,"C",aTam[1],aTam[2]})
aTam:=TamSX3("D1_QUANT")
AADD(aArqTemp,{"QUANTIDADE","N",16,aTam[2]})
aTam:=TamSX3("D1_COD")
AADD(aArqTemp,{"PRODUTO"   ,"C",aTam[1],aTam[2]})
AADD(aArqTemp,{"IDENTUF"   ,"C",1,0})
cArqTemp2:=CriaTrab(aArqTemp)
cIndTemp2:=Substr(CriaTrab(NIL,.F.),1,7)+"1"
cIndTemp3:=Substr(CriaTrab(NIL,.F.),1,7)+"2"
dbUseArea(.T.,nil,cArqTemp2,"ITECOM",.T.,.F.)
IndRegua("ITECOM",cIndTemp2,"PRODUTO+DTOS(DTDIGIT)+FORNECEDOR")
IndRegua("ITECOM",cIndTemp3,"IDENTUF+PRODUTO+DTOS(DTDIGIT)+FORNECEDOR")
Set Cursor Off
DbClearIndex()
DbSetIndex(cIndTemp2+OrdBagExt())
DbSetIndex(cIndTemp3+OrdBagExt())

// ITEVEN - Item do mapa de vendas
aArqTemp :={}
aTam:=TamSX3("B1_DESC")
AADD(aArqTemp,{"DESCRIPRO"	,"C",aTam[1],aTam[2]})
AADD(aArqTemp,{"EMISSAO"	,"D",8,0})
aTam:=TamSX3("D2_CLIENTE")
AADD(aArqTemp,{"CLIENTE"	,"C",aTam[1],aTam[2]})
aTam:=TamSX3("D2_LOJA")
AADD(aArqTemp,{"LOJA"		,"C"  ,aTam[1],aTam[2]})
aTam:=TamSX3("A1_NOME")
AADD(aArqTemp,{"DESCRICLI"	,"C",aTam[1],aTam[2]})
aTam:=TamSX3("A1_END")
AADD(aArqTemp,{"ADRESS"  	,"C",aTam[1],aTam[2]})
aTam:=TamSX3("A1_CEP")
AADD(aArqTemp,{"CEP"		,"C",aTam[1],aTam[2]})
aTam:=TamSX3("A1_MUN")
AADD(aArqTemp,{"MUNICIPIO"	,"C",aTam[1],aTam[2]})
aTam:=TamSX3("A1_EST")
AADD(aArqTemp,{"UF"			,"C",aTam[1],aTam[2]})
aTam:=TamSX3("D2_DOC")
AADD(aArqTemp,{"DOCUMENTO"	,"C",aTam[1],aTam[2]})
aTam:=TamSX3("D2_QUANT")
AADD(aArqTemp,{"QUANTIDADE"	,"N",16,aTam[2]})
aTam:=TamSX3("D2_COD")
AADD(aArqTemp,{"PRODUTO"	,"C",aTam[1],aTam[2]})
cArqTemp3:=CriaTrab(aArqTemp)
cIndTemp4:=Substr(CriaTrab(NIL,.F.),1,7)+"1"
dbUseArea(.T.,nil,cArqTemp3,"ITEVEN",.T.,.F.)
IndRegua("ITEVEN",cIndTemp4,"PRODUTO+DTOS(EMISSAO)+CLIENTE")
Set Cursor Off
DbClearIndex()
DbSetIndex(cIndTemp4+OrdBagExt())

// Alimenta arquivos de trabalho com dados
dbSelectArea("SB1")
dbSetOrder(1)
dbSeek(xFilial("SB1")+mv_par01,.T.)
SetRegua(LastRec())
While !lEnd .and. !eof() .And. xFilial("SB1") == B1_FILIAL .And. B1_COD <= mv_par02
	IncRegua()
	// Filtra Grupo	
	If B1_GRUPO < mv_par05 .Or. B1_GRUPO > mv_par06
		dbSkip()
		Loop	
	EndIf
	// Filtra Tipo
	If B1_TIPO < mv_par07 .Or. B1_TIPO > mv_par08
		dbSkip()
		Loop	
	EndIf                                                    	
	If Interrupcao(@lEnd)
		Exit
	Endif
	// TOTCOM - Totalizador do mapa de compras - 
	// INDICE -> PRODUTO
	// "PRODUTO" 
	// "SALDOANT" 
	// "COMPRAS"  
	// "VENDAS"   
	// "CONSUMO"  
	// "ESTOQFIM"
	If mv_par10 == 1 .Or. mv_par12 == 1
		dbSelectArea("TOTCOM")
		If !dbSeek(SB1->B1_COD)
	    	dbSelectArea("SB2")
    		dbSetOrder(1)
    		dbSeek(xFilial("SB2")+SB1->B1_COD)
			nSaldoIni:=0
	    	While !EOF() .And. B2_FILIAL+B2_COD == xFilial("SB2")+SB1->B1_COD
				aSaldo:=CalcEst(SB2->B2_COD,SB2->B2_LOCAL,dDataIni)
    			nSaldoIni+=	aSaldo[1]
				dbSkip()
	    	End
			Reclock("TOTCOM",.T.)
			Replace PRODUTO   With SB1->B1_COD
			Replace DESCRIPRO With SB1->B1_DESC
			Replace UM        With SB1->B1_UM
			Replace SEGUM     With SB1->B1_SEGUM
			Replace SALDOANT  With nSaldoIni
			Replace ESTOQFIM  With nSaldoIni
			MsUnlock()
		EndIf	
	EndIf	
	// Carrega informacoes para o Mapa de Compras
	If mv_par10 == 1 .Or. mv_par12 == 1
		dbSelectArea("SD1")
		dbSetOrder(7)
		dbSeek(xFilial("SD1")+SB1->B1_COD+mv_par03+DTOS(dDataIni),.T.)
		While !Eof() .And. D1_FILIAL+D1_COD == xFilial("SD1")+SB1->B1_COD .And. D1_LOCAL <= mv_par04 .And. DTOS(D1_DTDIGIT) <= DTOS(dDataFim)
			//Ŀ
			// Verifica se a data e valida         
			//
			If DTOS(D1_DTDIGIT) < DTOS(dDataIni)
				dbSkip()
				Loop			
			EndIf
			//Ŀ
			// Verifica se o TES atualiza estoque  
			//
			dbSelectArea("SF4")
			dbSeek(xFilial("SF4")+SD1->D1_TES)
			dbSelectArea("SD1")
			If SF4->F4_ESTOQUE != "S"
				dbSkip()
				Loop
			EndIf
			A462GrTrb("SD1",D1_COD,D1_QUANT,D1_DTDIGIT,D1_FORNECE,D1_LOJA,D1_TIPO,D1_DOC,dDataIni,SB1->B1_DESC)
			dbSelectArea("SD1")
			dbSkip()
		End
		dbSelectArea("SD3")
		dbSetOrder(7)
		dbSeek(xFilial("SD3")+SB1->B1_COD+mv_par03+DTOS(dDataIni),.T.)
		While !Eof() .And. D3_FILIAL+D3_COD == xFilial("SD3")+SB1->B1_COD .And. D3_LOCAL <= mv_par04 .And. DTOS(D3_EMISSAO) <= DTOS(dDataFim)
			//Ŀ
			// Verifica se a data e valida         
			//
			If DTOS(D3_EMISSAO) < DTOS(dDataIni)
				dbSkip()
				Loop			
			EndIf
			A462GrTrb("SD3",D3_COD,D3_QUANT*If(D3_TM <= "500",-1,1),D3_EMISSAO,NIL,NIL,NIL,D3_DOC,dDataIni,SB1->B1_DESC)
			dbSelectArea("SD3")
			dbSkip()
		End
	EndIf	
	// Carrega informacoes para o Mapa de Compras e/ou Mapa de Vendas e/ou Mapa do Exercito
	If mv_par10 == 1 .Or. mv_par11 == 1 .Or. mv_par12 == 1
		dbSelectArea("SD2")
		dbSetOrder(6)
		dbSeek(xFilial("SD2")+SB1->B1_COD+mv_par03+DTOS(dDataIni),.T.)
		While !Eof() .And. D2_FILIAL+D2_COD == xFilial("SD2")+SB1->B1_COD .And. D2_LOCAL <= mv_par04 .And. DTOS(D2_EMISSAO) <= DTOS(dDataFim)
			//Ŀ
			// Verifica se a data e valida         
			//
			If DTOS(D2_EMISSAO) < DTOS(dDataIni)
				dbSkip()
				Loop			
			EndIf
			//Ŀ
			// Verifica se o TES atualiza estoque  
			//
			dbSelectArea("SF4")
			dbSeek(xFilial("SF4")+SD2->D2_TES)
			dbSelectArea("SD2")
			If SF4->F4_ESTOQUE != "S"
				dbSkip()
				Loop
			EndIf
			A462GrTrb("SD2",D2_COD,D2_QUANT,D2_EMISSAO,D2_CLIENTE,D2_LOJA,D2_TIPO,D2_DOC,dDataIni,SB1->B1_DESC)
			dbSelectArea("SD2")
			dbSkip()
		End
	EndIf
	dbSelectArea("SB1")
	dbSkip()
End

// Imprime relatorios
nLin   :=80
nLinMax:=45
If mv_par10 == 1
	// Carrega Layout	
	aL:=R462LCom()
	// Imprime Capa
    dbSelectArea("TOTCOM")
    dbGotop()
    While !Eof()
		If nLin > 60
			R462Cabec(@nLin,1,aMesOrd,aL)		
		EndIf
		FmtLin({PRODUTO,Substr(DESCRIPRO,1,29),SALDOANT,COMPRAS,VENDAS,CONSUMO,ESTOQFIM},aL[17],,,@nLin)
		dbSkip()
		If (Eof() .And. nLin <= nLinMax) .Or. nLin > nLinMax
			While nLin <= nLinMax
				FmtLin(,aL[18],,,@nLin)			   
			End		
			R462Cabec(@nLin,2,aMesOrd,aL)		
		EndIf
    End
    // Imprime interior
	nLinMax:=50
    dbSelectArea("ITECOM")
    dbSetOrder(1)
    dbGotop()
    While !Eof()
		If nLin > 60
			R462Cabec(@nLin,3,aMesOrd,aL)		
		EndIf
		FmtLin({DTDIGIT,FORNECEDOR,LOJA,Substr(DESCRIFOR,1,If(nTamForn>8 .And. nTamCPro >15, 17,28)),Substr(ADRESS,1,41),CEP,Substr(MUNICIPIO,1,15),UF,DOCUMENTO,QUANTIDADE,PRODUTO,Substr(DESCRIPRO,1,27)},aL[37],,,@nLin)
		dbSkip()
		If (Eof() .And. nLin <= nLinMax) .Or. nLin > nLinMax
			While nLin <= nLinMax
				FmtLin(,aL[39],,,@nLin)			   
			End		
			R462Cabec(@nLin,4,aMesOrd,aL)		
		EndIf
    End
EndIf

If mv_par11 == 1
	nlinMax:=45
	// Carrega Layout	
	aL:=R462LVen()
	// Imprime interior
    dbSelectArea("ITEVEN")
    dbGotop()
    While !Eof()
		If nLin > 60
			R462Cabec(@nLin,If(lFirst,5,6),aMesOrd,aL)		
		EndIf
		FmtLin({EMISSAO,CLIENTE,LOJA,Substr(DESCRICLI,1,If(nTamForn>8 .And. nTamCPro >15, 17,28)),Substr(ADRESS,1,41),CEP,Substr(MUNICIPIO,1,15),UF,DOCUMENTO,QUANTIDADE,PRODUTO,Substr(DESCRIPRO,1,27)},aL[17],,,@nLin)
		dbSkip()
		If (Eof() .And. nLin <= nLinMax) .Or. nLin > nLinMax
			While nLin <= 50
				FmtLin(,aL[18],,,@nLin)			   
			End		
			R462Cabec(@nLin,If(lFirst,7,8),aMesOrd,aL)		
			If lFirst
				lFirst:=.F.			
				nLinMax:=50
			EndIf
		EndIf
    End
EndIf

If mv_par12 == 1
	lFirst:=.T.
	nlinMax:=45
	// Carrega Layout	
	aL:=R462LExe()
	// Imprime Capa
    dbSelectArea("TOTCOM")
    dbGotop()
    While !Eof()
		If nLin > 60
			R462Cabec(@nLin,If(lFirst,9,11),aMesOrd,aL)		
		EndIf
		FmtLin({PRODUTO,Substr(DESCRIPRO,1,29),SALDOANT,COMPRAS,SALDOANT+COMPRAS,CONSUMO,VENDAS,ESTOQFIM,If(UM=="KG",ESTOQFIM,If(SEGUM=="KG",ConvUm(PRODUTO,ESTOQFIM,0,2),0))},aL[16],,,@nLin)
		dbSkip()
		If (Eof() .And. nLin <= nLinMax) .Or. nLin > nLinMax
			While nLin <= nLinMax
				FmtLin(,aL[17],,,@nLin)			   
			End		
			If !Eof()
				R462Cabec(@nLin,If(lFirst,10,11),aMesOrd,aL)		
			EndIf
			If lFirst
				lFirst:=.F.			
				nLinMax:=55
			EndIf
		EndIf
    End
	nLinMax:=60
    // Imprime DETALHE SP
	R462Cabec(@nLin,12,aMesOrd,aL)		
    dbSelectArea("ITECOM")
    dbSetOrder(2)
    dbSeek("1")
    While !Eof() .And. IDENTUF == "1"
		If nLin > nLinMax
			R462Cabec(@nLin,12,aMesOrd,aL)		
		EndIf
		FmtLin({DTDIGIT,FORNECEDOR,LOJA,Substr(DESCRIFOR,1,If(nTamForn>8 .And. nTamCPro >15, 17,28)),Substr(ADRESS,1,41),Substr(MUNICIPIO,1,15),UF,"",DOCUMENTO,QUANTIDADE,PRODUTO,Substr(DESCRIPRO,1,27)},aL[25],,,@nLin)
		dbSkip()
    End                                     
    // Imprime DETALHE OUTROS ESTADOS
	R462Cabec(@nLin,13,aMesOrd,aL)		
    dbSelectArea("ITECOM")
    dbSetOrder(2)
    dbSeek("2")
    While !Eof() .And. IDENTUF == "2"
		If nLin > nLinMax
			R462Cabec(@nLin,14,aMesOrd,aL)		
		EndIf
		FmtLin({DTDIGIT,FORNECEDOR,LOJA,Substr(DESCRIFOR,1,If(nTamForn>8 .And. nTamCPro >15, 17,28)),Substr(ADRESS,1,41),Substr(MUNICIPIO,1,15),UF,"",DOCUMENTO,QUANTIDADE,PRODUTO,Substr(DESCRIPRO,1,27)},aL[25],,,@nLin)
		dbSkip()
    End
	While nLin < nLinMax
		FmtLin(,aL[39],,,@nLin)			   
	End		
	FmtLin(,aL[20],,,@nLin)
EndIf

//Ŀ
// Apaga Arquivos Temporarios                                   
//
dbSelectArea("TOTCOM")
dbCloseArea()
Ferase(cArqTemp1+GetDBExtension())
Ferase(cIndTemp1+OrdBagExt())
dbSelectArea("ITECOM")
dbCloseArea()
Ferase(cArqTemp2+GetDBExtension())
Ferase(cIndTemp2+OrdBagExt())
Ferase(cIndTemp3+OrdBagExt())
dbSelectArea("ITEVEN")
dbCloseArea()
Ferase(cArqTemp3+GetDBExtension())
Ferase(cIndTemp4+OrdBagExt())
Return

/*


Ŀ
Funo    A462GrTrb  Autor Rodrigo de A Sartorio   Data  04/08/04 
Ĵ
Descrio  Funcao que grava os arquivos de trabalho utilizados na     
           impressao do relatorio                                     
Ĵ
Sintaxe   A462GrTrb(ExpC1,ExpC2,ExpN1,ExpD1,ExpC3,ExpC4,ExpC5,ExpC6,  
			 		    ExpD2,ExpC7)									  
Ĵ
Parametros ExpC1 = Arquivo origem das informacoes                     
           ExpC2 = Codigo do produto do movimento               	  
           ExpN1 = Quantidade do movimento                            
           ExpD1 = Data do movimento                                  
           ExpC3 = Codigo do cliente / fornecedor do movimento    	  
           ExpC4 = Loja  do cliente / fornecedor do movimento  		  
           ExpC5 = Tipo do documento do movimento               	  
           ExpC6 = Documento do movimento                   	      
           ExpD2 = Data inicio do processamento         	          
           ExpC7 = Descricao do produto do movimento 	              
Ĵ
Retorno    Nenhum                                                     
Ĵ
 Uso       MATR462                                                    
ٱ


*/
Static Function A462GrTrb(cAlias,cProduto,nQuant,dData,cCliFor,cLoja,cTipoDoc,cDoc,dDataIni,cDescri)
LOCAL cEnder:=""
LOCAL cCep:=""
LOCAL cMun:=""
LOCAL cUF:=""
LOCAL cDescriCli:=""

//Ŀ
// Posiciona registros                                          
//
If Valtype(cCliFor) == "C" .And. !Empty(cCliFor)
	If (cTipoDoc$"DB" .And. cAlias == "SD1") .Or. (!(cTipoDoc$"DB") .And. cAlias == "SD2")
		dbSelectArea("SA1")
		dbSetOrder(1)
		If MsSeek(xFilial("SA1")+cCliFor+cLoja)
			cEnder    :=SA1->A1_END
			cCep      :=SA1->A1_CEP
			cMun      :=SA1->A1_MUN
			cUF       :=SA1->A1_EST
			cDescriCli:=SA1->A1_NOME
		EndIf	
	Else
		dbSelectArea("SA2")
		dbSetOrder(1)
		If MsSeek(xFilial("SA2")+cCliFor+cLoja)
			cEnder    :=SA2->A2_END
			cCep      :=SA2->A2_CEP
			cMun      :=SA2->A2_MUN
			cUF       :=SA2->A2_EST
			cDescriCli:=SA2->A2_NOME
		EndIf	
	EndIf
EndIf	

// ITECOM - Item do mapa de compras
// INDICE -> DTOS(DTDIGIT)+FORNECEDOR+PRODUTO
// "DTDIGIT"
// "FORNECEDOR"
// "LOJA"
// "ADRESS"
// "CEP"      
// "MUNICIPIO" 
// "UF" 
// "DOCUMENTO" 
// "QUANTIDADE"
// "PRODUTO"   
If (mv_par10 == 1 .Or. mv_par12 == 1) .And. cAlias $ "SD1/SD3"
	If cAlias == "SD1"
		// Grava item
		Reclock("ITECOM",.T.)
		Replace DTDIGIT    With dData
		Replace FORNECEDOR With cCliFor
		Replace LOJA       With cLoja
		Replace DESCRIFOR  With cDescriCli
		Replace ADRESS     With Substr(cEnder,1,Len(ITECOM->ADRESS))
		Replace CEP        With cCep
		Replace MUNICIPIO  With Substr(cMun,1,Len(ITECOM->MUNICIPIO))
		Replace UF         With cUF
		Replace DOCUMENTO  With cDoc
		Replace QUANTIDADE With nQuant
		Replace PRODUTO    With cProduto
		Replace DESCRIPRO  With cDescri
		Replace IDENTUF    With If(cUF=="SP","1","2")
		MsUnlock()
		// Grava totalizador
		Reclock("TOTCOM",.F.)
		Replace COMPRAS   With COMPRAS+nQuant
		Replace ESTOQFIM  With ESTOQFIM+nQuant
		MsUnlock()
	Else
		// Grava totalizador
		Reclock("TOTCOM",.F.)
		Replace CONSUMO   With CONSUMO+nQuant
		Replace ESTOQFIM  With ESTOQFIM+(nQuant*-1)
		MsUnlock()
	EndIf
EndIf

// ITEVEN - Item do mapa de vendas
// INDICE -> DTOS(EMISSAO)+CLIENTE+PRODUTO
// "EMISSAO"
// "CLIENTE"
// "LOJA"
// "ADRESS"
// "CEP"      
// "MUNICIPIO" 
// "UF"
// "DOCUMENTO" 
// "QUANTIDADE"
// "PRODUTO"   
If (mv_par10 ==1 .Or. mv_par11 == 1 .Or. mv_par12 == 1) .And. cAlias == "SD2"
	// Grava item
	Reclock("ITEVEN",.T.)
	Replace EMISSAO    With dData
	Replace CLIENTE    With cCliFor
	Replace LOJA       With cLoja
	Replace DESCRICLI  With cDescriCli
	Replace ADRESS     With Substr(cEnder,1,Len(ITEVEN->ADRESS))
	Replace CEP        With cCep
	Replace MUNICIPIO  With Substr(cMun,1,Len(ITEVEN->MUNICIPIO))
	Replace UF         With cUF
	Replace DOCUMENTO  With cDoc
	Replace QUANTIDADE With nQuant
	Replace PRODUTO    With cProduto
	Replace DESCRIPRO  With cDescri	
	MsUnlock()
	If mv_par10 == 1 .Or. mv_par12 == 1
		// Grava totalizador
		Reclock("TOTCOM",.F.)
		Replace VENDAS    With VENDAS+nQuant
		Replace ESTOQFIM  With ESTOQFIM-nQuant
		MsUnlock()
	EndIf	
EndIf
Return

/*


Ŀ
Funo    AjustaPerg Autor Rodrigo de A Sartorio   Data  03.08.04 
Ĵ
Descrio  Funcao que inclui perguntas e help das mesmas no SX1       
Ĵ
Parametros ExpC1 = grupo de perguntas do relatorio                	  
Ĵ
Retorno    Nenhum                                                     
Ĵ
 Uso       MATR462                                                    
ٱ


*/
Static Function AjustaPerg(cPerg)
Local aHelpPor
Local aHelpEng
Local aHelpSpa
Local aArea	:=GetArea()
Local nTamSX1

PutSx1(cPerg,"01","De  Produto"      ,"De Producto"      ,"From Product"     ,"mv_ch1","C",15,0,0,"G","","SB1","","","mv_par01","","","","","","","","","","","","","","","","")
PutSx1(cPerg,"02","At Produto"      ,"A  Producto"      ,"To Product"       ,"mv_ch2","C",15,0,0,"G","","SB1","","","mv_par02","","","","ZZZZZZZZZZZZZZZ","","","","","","","","","","","","")
PutSx1(cPerg,"03","De  Armazem"      ,"De Deposito"      ,"From Warehouse"   ,"mv_ch3","C",02,0,0,"G","","","","","mv_par03","","","","","","","","","","","","","","","","")
PutSx1(cPerg,"04","At Armazem"      ,"A  Deposito"      ,"To Warehouse"     ,"mv_ch4","C",02,0,0,"G","","","","","mv_par04","","","","ZZ","","","","","","","","","","","","")
PutSx1(cPerg,"05","De  Grupo"        ,"De Grupo"         ,"From Group"       ,"mv_ch5","C",04,0,0,"G","","SBM","","","mv_par05","","","","","","","","","","","","","","","","")
PutSx1(cPerg,"06","At Grupo"        ,"A  Grupo"         ,"To Group"         ,"mv_ch6","C",04,0,0,"G","","SBM","","","mv_par06","","","","ZZZZ","","","","","","","","","","","","")
PutSx1(cPerg,"07","De  Tipo"         ,"De Tipo"          ,"From Type"        ,"mv_ch7","C",02,0,0,"G","","02 ","","","mv_par07","","","","","","","","","","","","","","","","")
PutSx1(cPerg,"08","At Tipo"         ,"A  Tipo"          ,"To Type"          ,"mv_ch8","C",02,0,0,"G","","02 ","","","mv_par08","","","","ZZ","","","","","","","","","","","","")
PutSx1(cPerg,"09","Trimestre"        ,"Trimestre"    	 ,"Quarter"          ,"mv_ch9","N",01,0,0,"G","(mv_par09 >= 1 .and. mv_par09 <= 4)","","","","mv_par09","","","","1","","","","","","","","","","","","")
PutSx1(cPerg,"10","Mapa Civil Compra","Mapa Civil Compra","Purchase civilian map?","mv_cha","N",01,0,1,"C","","","","","mv_par10","Sim","Si","Yes","","Nao","No","No")
PutSx1(cPerg,"11","Mapa Civil Venda" ,"Mapa Civil Venta" ,"Sales civilian map?"   ,"mv_chb","N",01,0,1,"C","","","","","mv_par11","Sim","Si","Yes","","Nao","No","No")
PutSx1(cPerg,"12","Mapa Exercito"    ,"Mapa Ejercito"    ,"Army civilian map?"    ,"mv_chc","N",01,0,1,"C","","","","","mv_par12","Sim","Si","Yes","","Nao","No","No")
PutSx1(cPerg,"13","Informe a RM"	 ,"Informe RM" 		 ,"Enter MR"	 ,"mv_chd","N",02,0,0,"G","(mv_par13>0)"					   ,"","","","mv_par13","","","","","","","","","","","","","","","","")
PutSx1(cPerg,"14","Informe o CR"	 ,"Informe CR"		 ,"Enter RC"	 ,"mv_che","C",20,0,0,"G","","","","","mv_par14","","","","","","","","","","","","","","","","")
PutSx1(cPerg,"15","CR Valido at ?"	 ,"A CR Valido?"	 ,"To valid RC?" ,"mv_chf","D",08,0,0,"G","","","","","mv_par15","","","","","","","","","","","","","","","","")

/*-----------------------MV_PAR01--------------------------*/
aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 

Aadd (aHelpPor, "Produto inicial a ser considerado na    ")
Aadd (aHelpPor, "filtragem do cadastro de produtos (SB1).")

Aadd (aHelpEng, "Initial product to be considered when   ")
Aadd (aHelpEng, "filtering products file (SB1).          ")

Aadd (aHelpSpa, "Producto inicial que se considerara en  ")
Aadd (aHelpSpa, "el filtro del archivo de productos(SB1).")
PutSX1Help("P.MTR46201.",aHelpPor,aHelpEng,aHelpSpa)

/*-----------------------MV_PAR02--------------------------*/
aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 
Aadd (aHelpPor, "Produto final a ser considerado na      ")
Aadd (aHelpPor, "filtragem do cadastro de produtos (SB1).")

Aadd (aHelpEng, "Final product to be considered when     ")
Aadd (aHelpEng, "filtering products file (SB1).                ")

Aadd (aHelpSpa, "Producto final que se considerara en el ")
Aadd (aHelpSpa, "filtro del archivo de productos (SB1).  ")
PutSX1Help("P.MTR46202.",aHelpPor,aHelpEng,aHelpSpa)

/*-----------------------MV_PAR03--------------------------*/
aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 
Aadd (aHelpPor, "Armazm inicial a ser considerado na    ")
Aadd (aHelpPor, "filtragem dos arquivos: itens de NF de  ")
Aadd (aHelpPor, "Entrada (SD1), itens do pedido de venda ")
Aadd (aHelpPor, "(SD2) e movimentos internos (SD3).      ")

Aadd (aHelpEng, "Initial wharehouse to be considered when")
Aadd (aHelpEng, " filtering the files: Inflow Invoice    ")
Aadd (aHelpEng, "Items (SD1), sales order items (SD2) and")
Aadd (aHelpEng, "internal transactions (SD3).            ")

Aadd (aHelpSpa, "Almacen inicial que se considerara en el")
Aadd (aHelpSpa, "filtro del archivo: items de Fac.Entrada")
Aadd (aHelpSpa, "(SD1), items del pedido de venta (SD2)  ")
Aadd (aHelpSpa, "y movimientos internos (SD3).           ")
PutSX1Help("P.MTR46203.",aHelpPor,aHelpEng,aHelpSpa)

/*-----------------------MV_PAR04--------------------------*/
aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 
Aadd (aHelpPor, "Armazm final a ser considerado na      ")
Aadd (aHelpPor, "filtragem dos arquivos: itens de NF de  ")
Aadd (aHelpPor, "Entrada(SD1), itens do pedido de venda  ")
Aadd (aHelpPor, "(SD2) e movimentos internos (SD3).      ")

Aadd (aHelpEng, "Final wharehouse to be considered when  ")
Aadd (aHelpEng, "filtering the files: Inflow Invoice     ")
Aadd (aHelpEng, "Items (SD1), sales order items (SD2) and")
Aadd (aHelpEng, "internal transactions (SD3).            ")

Aadd (aHelpSpa, "Almacen final que se considerara en el  ")
Aadd (aHelpSpa, "filtro del archivo: items de Fac.Entrada")
Aadd (aHelpSpa, "(SD1), items del pedido de venta (SD2)  ")
Aadd (aHelpSpa, "y movimientos internos (SD3).           ")
PutSX1Help("P.MTR46204.",aHelpPor,aHelpEng,aHelpSpa)

/*-----------------------MV_PAR05--------------------------*/
aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 
Aadd (aHelpPor, "Grupo inicial a ser considerado na      ")
Aadd (aHelpPor, "filtragem do cadastro de produtos (SB1).")

Aadd (aHelpEng, "Initial group to be considered when     ")
Aadd (aHelpEng, "filtering products file (SB1).          ")

Aadd (aHelpSpa, "Grupo inicial por considerarse en el    ")
Aadd (aHelpSpa, "filtro del archivo de productos (SB1).  ")
PutSX1Help("P.MTR46205.",aHelpPor,aHelpEng,aHelpSpa)

/*-----------------------MV_PAR06--------------------------*/
aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 
Aadd (aHelpPor, "Grupo final a ser considerado na        ")
Aadd (aHelpPor, "filtragem do cadastro de produtos (SB1).")

Aadd (aHelpEng, "Final group to be considered when       ")
Aadd (aHelpEng, "filtering products file (SB1).          ")

Aadd (aHelpSpa, "Grupo final por considerarse en el      ")
Aadd (aHelpSpa, "filtro del archivo de productos (SB1).  ")
PutSX1Help("P.MTR46206.",aHelpPor,aHelpEng,aHelpSpa)

/*-----------------------MV_PAR07--------------------------*/
aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 
Aadd (aHelpPor, "Tipo inicial a ser considerado na       ")
Aadd (aHelpPor, "filtragem do cadastro de produtos (SB1).")

Aadd (aHelpEng, "Initial type to be considered when      ")
Aadd (aHelpEng, "filtering products file (SB1).          ")

Aadd (aHelpSpa, "Tipo inicial por considerarse en el     ")
Aadd (aHelpSpa, "filtro del archivo de productos (SB1).  ")
PutSX1Help("P.MTR46207.",aHelpPor,aHelpEng,aHelpSpa)

/*-----------------------MV_PAR08--------------------------*/
aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 
Aadd (aHelpPor, "Tipo final a ser considerado na         ")
Aadd (aHelpPor, "filtragem do cadastro de produtos (SB1).")

Aadd (aHelpEng, "Final type to be considered when        ")
Aadd (aHelpEng, "filtering products file (SB1).          ")

Aadd (aHelpSpa, "Tipo final por considerarse en el filtro")
Aadd (aHelpSpa, " del archivo de productos (SB1).        ")
PutSX1Help("P.MTR46208.",aHelpPor,aHelpEng,aHelpSpa)

/*-----------------------MV_PAR09--------------------------*/
aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 
Aadd (aHelpPor, "Entre com o Trimestre a ser considerado ")
Aadd (aHelpPor, "para o relatrio.                       ")

Aadd (aHelpEng, "Enter the Quarter to be considered for  ")
Aadd (aHelpEng, "the report.                             ")

Aadd (aHelpSpa, "Ingrese el trimestre que se considerara ")
Aadd (aHelpSpa, " en el informe.                         ")
PutSX1Help("P.MTR46209.",aHelpPor,aHelpEng,aHelpSpa)

/*-----------------------MV_PAR10--------------------------*/
aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 
Aadd (aHelpPor, "Informe se o relatrio ir imprimir o   ")
Aadd (aHelpPor, "Mapa Civil de Compra.                   ")

Aadd (aHelpEng, "Enter whether the report prints the     ")
Aadd (aHelpEng, "Civil Map of Purchase.                  ")

Aadd (aHelpSpa, "Informe si el informe imprimira el mapa ")
Aadd (aHelpSpa, "civil de compra.                        ")
PutSX1Help("P.MTR46210.",aHelpPor,aHelpEng,aHelpSpa)

/*-----------------------MV_PAR11--------------------------*/
aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 
Aadd (aHelpPor, "Informe se o relatrio ir imprimir o   ")
Aadd (aHelpPor, "Mapa Civil de Venda.                    ")

Aadd (aHelpEng, "Enter whether the report prints the     ")
Aadd (aHelpEng, "Civil Map of Sales.                     ")

Aadd (aHelpSpa, "Informe si el informe imprimira el mapa ")
Aadd (aHelpSpa, "civil de venta.                         ")
PutSX1Help("P.MTR46211.",aHelpPor,aHelpEng,aHelpSpa)

/*-----------------------MV_PAR12--------------------------*/
aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 
Aadd (aHelpPor, "Informe se o relatrio ir imprimir o   ")
Aadd (aHelpPor, "Mapa do Exrcito.                       ")

Aadd (aHelpEng, "Enter whether the report prints the     ")
Aadd (aHelpEng, "Army Map.                               ")

Aadd (aHelpSpa, "Informe si el informe imprimira el mapa ")
Aadd (aHelpSpa, "del ejercito.                           ")
PutSX1Help("P.MTR46212.",aHelpPor,aHelpEng,aHelpSpa)

/*-----------------------MV_PAR13--------------------------*/
aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 
Aadd (aHelpPor, "Informe a RM - Regiao Militar.          ")
Aadd (aHelpEng, "Enter RM - Military Region.             ")
Aadd (aHelpSpa, "Informe la RM - Region Militar.         ")
PutSX1Help("P.MTR46213.",aHelpPor,aHelpEng,aHelpSpa)

/*-----------------------MV_PAR14--------------------------*/
aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 
Aadd (aHelpPor, "Informe o CR - Certificado de Registro. ")
Aadd (aHelpEng, "Enter CR - Certificate of Registration. ")
Aadd (aHelpSpa, "Informe el CR - Certificado de Registro.")
PutSX1Help("P.MTR46214.",aHelpPor,aHelpEng,aHelpSpa)

/*-----------------------MV_PAR15--------------------------*/
aHelpPor :={} 
aHelpEng :={} 
aHelpSpa :={} 
Aadd (aHelpPor, "Informe a Validade do CR - Certificado  ")
Aadd (aHelpPor, "de Registro.                            ")

Aadd (aHelpEng, "Enter the CR Maturity - Certificate of  ")
Aadd (aHelpEng, "Record.                                 ")

Aadd (aHelpSpa, "Informe la validez del CR - Certificado ")
Aadd (aHelpSpa, "de Registro.                            ")
PutSX1Help("P.MTR46215.",aHelpPor,aHelpEng,aHelpSpa)

dbSelectArea("SX1")
dbSetOrder(1)
nTamSX1 := Len(SX1->X1_GRUPO)

If dbSeek(PADR("MTR462",nTamSX1)+"09",.F.)
	// Corrige valor inicial do Trimestre
	If Val(X1_CNT01)<1 .Or. Val(X1_CNT01)>4
		RecLock("SX1",.F.)
		Replace X1_CNT01 With "1"
		MsUnlock()
	EndIf
EndIf

RestArea(aArea)
Return

/*


Ŀ
Funo    R462LCom   Autor Rodrigo de A Sartorio   Data  02.08.04 
Ĵ
Descrio  Lay-Out do Mapa de Compra                                  
Ĵ
Parametros Nenhum                                                     
Ĵ
Retorno    ExpA1 = Array com as strings para a impressao              
Ĵ
 Uso       MATR462                                                    
ٱ


*/
Static Function R462LCom()
Local aL		:= Array(44)
Local nTamCPro	:= TamSX3("B1_COD")[1]
Local nTamForn  := TamSX3("D1_FORNECE")[1]

aL[01]:=STR0010 //"|-----------------------------------------------------------------------------------------------------------+-------------------------------------------------------------------------------------------------------------|"
aL[02]:=STR0011 //"| MAPA TRIMESTRAL                                                                                           |                                       MAPA TRIMESTRAL DE ENTRADA, DE ESTOQUE E                              |"
aL[03]:=STR0012 //"|                                                                                                           |                                           COMPRAS DE PRODUTOS CONTROLADOS                                   |"
aL[04]:=STR0013 //"|                                                                                                           |                                                                                                             |"
aL[05]:=STR0014 //"|                                                                                                           |                                                                 REFERENTE AO ############ TRIMESTRE DE #### |"
aL[06]:=STR0015 //"|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|"
aL[07]:=STR0016 //"| FIRMA:    ##########################################################################                                                                                        INSC.EST.: ################                 |"
aL[08]:=STR0017 //"| ENDERECO: ##########################################################################                                                                                        CNPJ (MF): ################################ |"
aL[09]:=STR0018 //"| CIDADE:   ###########################################################  CEP #########                                                                                                                                    |"
aL[10]:=STR0019 //"| TELEFONES:##########################################################################                                                                                                                                    |"
aL[11]:=STR0020 //"| MAPA TRIMESTRAL DEMONSTRATIVO DO ESTOQUE, DE COMPRAS VENDA E CONSUMO                                                                                                                                                    |"
aL[12]:=STR0015 //"|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|"
If nTamCPro > 15
	aL[13]:=STR0077 //"|                                                               |     SALDO DO     |                  |                  |                  |                                                                             |"
	aL[14]:=STR0078 //"|                         PRODUTOS                              |     TRIMESTRE    |      COMPRAS     |      VENDAS      |     CONSUMO      |            ESTOQUE   QUE   PASSA   PARA   O   TRIMESTRE   SEGUINTE          |"
	aL[15]:=STR0079 //"|                                                               |     ANTERIOR     |                  |                  |                  |                                                                             |"
	aL[16]:=STR0080 //"|---------------------------------------------------------------+------------------+------------------+------------------+------------------+-----------------------------------------------------------------------------|"
	aL[17]:=STR0081 //"| ############################## ############################## | ################ | ################ | ################ | ################ | ################                                                            |"
	aL[18]:=STR0082 //"|                                                               |                  |                  |                  |                  |                                                                             |"
	aL[19]:=STR0080 //"|---------------------------------------------------------------+------------------+------------------+------------------+------------------+-----------------------------------------------------------------------------|"
Else
	aL[13]:=STR0021 //"|                                               |     SALDO DO     |                  |                  |                  |                                                                                             |"
	aL[14]:=STR0022 //"|                  PRODUTOS                     |     TRIMESTRE    |      COMPRAS     |      VENDAS      |     CONSUMO      |    E S T O Q U E   Q U E   P A S S A   P A R A   O   T R I M E S T R E   S E G U I N T E    |"
	aL[15]:=STR0023 //"|                                               |     ANTERIOR     |                  |                  |                  |                                                                                             |"
	aL[16]:=STR0024 //"|-----------------------------------------------+------------------+------------------+------------------+------------------+---------------------------------------------------------------------------------------------|"
	aL[17]:=STR0025 //"| ############### ##############################| ################ | ################ | ################ | ################ | ################                                                                            |"
	aL[18]:=STR0026 //"|                                               |                  |                  |                  |                  |                                                                                             |"
	aL[19]:=STR0024 //"|-----------------------------------------------+------------------+------------------+------------------+------------------+---------------------------------------------------------------------------------------------|"
EndIf
aL[20]:=STR0027 //"|  OBSERVACOES : FAZER EM (3) TRES VIAS.                                                                                                                                                                                  |"
aL[21]:=STR0028 //"|                ESTE MAPA E APRESENTADO TRIMESTRALMENTE (ATE O DIA 5),                                                                                                                                                   |"
aL[22]:=STR0029 //"|                COM O SALDO DO TRIMESTRE ANTERIOR.                                                                                               ######################### ## DE ############# DE ####                   |"
aL[23]:=STR0030 //"|                RELACAO DE COMPRAS NO VERSO.                                                                                                                                                                             |"
aL[24]:=STR0031 //"|                                                                                                                                                                                                                         |"
aL[25]:=STR0032 //"|                                                                                                                                                  ________________________________________________________               |"
aL[26]:=STR0033 //"|                                                                                                                                                     A S S I N A T U R A   D O   R E S P O N S A V E L                   |"
aL[27]:=STR0031 //"|                                                                                                                                                                                                                         |"
aL[28]:=STR0034 //"|                                                                                                                                                 N O M E ________________________________________________                |"
aL[29]:=STR0031 //"|                                                                                                                                                                                                                         |"
aL[30]:=STR0015 //"|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|"
aL[31]:=STR0035 //"| RELACAO DAS COMPRAS DURANTE O TRIMESTRE                                                                                                                                                                                 |"
aL[32]:=STR0015 //"|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|"
If nTamCPro > 15
	aL[33]:=STR0084 //"|          |                  FIRMA                    |                            E N D E R E C O                           |    NOTA     |                 |                                                           |"
	aL[34]:=STR0085 //"|  DATA    |                VENDEDORA                  |----------------------------------------------------------------------|             |    QUANTIDADE   |           P R O D U T O S     C O M P R A D O S           |"
	aL[35]:=STR0087 //"|          |                                           |             RUA E NUMERO                |   CEP   |    CIDADE     |UF|   FISCAL    |                 |                                                           |"
	aL[36]:=STR0088 //"|----------+-------------------------------------------+-----------------------------------------+---------+---------------+--+-------------+-----------------+-----------------------------------------------------------|"
	aL[37]:=STR0089 //"|##########|#################### #### #################|#########################################|#########|###############|##|############ |################ | ############################## ###########################|"
	aL[38]:=STR0088 //"|----------+-------------------------------------------+-----------------------------------------+---------+---------------+--+-------------+-----------------+-----------------------------------------------------------|"
	aL[39]:=STR0090 //"|          |                                           |                                         |         |               |  |             |                 |                                                           |"
Else
	aL[33]:=STR0036 //"|            |                    FIRMA                    |                                    E N D E R E C O                           |     NOTA     |                  |                                             |"
	aL[34]:=STR0037 //"|    DATA    |                  VENDEDORA                  |------------------------------------------------------------------------------|              |    QUANTIDADE    |       P R O D U T O S    C O M P R A D O S  |"
	aL[35]:=STR0038 //"|            |                                             |               RUA E NUMERO                |    CEP    |     CIDADE      | UF |    FISCAL    |                  |                                             |"
	aL[36]:=STR0039 //"|------------+---------------------------------------------+-------------------------------------------+-----------+-----------------+----+--------------+------------------+---------------------------------------------|"
	aL[37]:=STR0040 //"| ########## | ########## #### ########################### | ######################################### | ######### | ############### | ## | ############ | ################ | ############### ########################### |"
	aL[38]:=STR0039 //"|------------+---------------------------------------------+-------------------------------------------+-----------+-----------------+----+--------------+------------------+---------------------------------------------|"
	aL[39]:=STR0041 //"|            |                                             |                                           |           |                 |    |              |                  |                                             |"
EndIf
If nTamForn <= 8 .And. nTamCPro <= 15
	aL[37]:=STR0102 //"|##########|#################### #### #################|#########################################|#########|###############|##|############ |################ | ############################## ###########################|"
EndIf
aL[40]:=STR0015 //"|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|"
aL[41]:=STR0042 //"|                                          LICENCAS DE ACIDOS , TRANSPORTE , EXPLOSIVOS , CORROSIVOS                                                                                                                      |"
aL[42]:=STR0043 //"|                                          SFPC/2 - EXERCITO BRASILEIRO                                                                                                                                                   |"
aL[43]:=STR0044 //"|                                          DIRD     - DIVISAO DE PRODUTOS CONTROLADOS                                                                                                                                     |"
aL[44]:=STR0015 //"|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|"
//        1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890
//                 1         2         3         4         5         6         7         8         9        10        11        12        13        14        15        16        17        18        19        20        21        22        
Return (aL)

/*


Ŀ
Funo    R462LVen   Autor Rodrigo de A Sartorio   Data  02.08.04 
Ĵ
Descrio  Lay-Out do Mapa de Venda                                   
Ĵ
Parametros Nenhum                                                     
Ĵ
Retorno    ExpA1 = Array com as strings para a impressao              
Ĵ
 Uso       MATR462                                                    
ٱ


*/
Static Function R462LVen()
Local aL		:= Array(34)
Local nTamCPro	:= TamSX3("B1_COD")[1]
Local nTamCli	:= TamSX3("D2_CLIENTE")[1]

aL[01]:=STR0045 //"|----------------------------------------------------------------------------------------------------------+--------------------------------------------------------------------------------------------------------------|"
aL[02]:=STR0046 //"| MAPA TRIMESTRAL                                                                                          |                                        MAPA TRIMESTRAL DE VENDAS DE                                          |"
aL[03]:=STR0047 //"|                                                                                                          |                                            PRODUTOS CONTROLADOS                                              |"
aL[04]:=STR0048 //"|                                                                                                          |                                                                                                              |"
aL[05]:=STR0049 //"|                                                                                                          |                                                                  REFERENTE AO ############ TRIMESTRE DE #### |"
aL[06]:=STR0015 //"|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|"
aL[07]:=STR0016 //"| FIRMA:    ##########################################################################                                                                                        INSC.EST.: ################                 |"
aL[08]:=STR0017 //"| ENDERECO: ##########################################################################                                                                                        CNPJ (MF): ################################ |"
aL[09]:=STR0018 //"| CIDADE:   ###########################################################  CEP #########                                                                                                                                    |"
aL[10]:=STR0019 //"| TELEFONES:##########################################################################                                                                                                                                    |"
aL[11]:=STR0050 //"| RELACAO DAS VENDAS DURANTE O TRIMESTRE                                                                                                                                                                                  |"
aL[12]:=STR0015 //"|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|"
If nTamCPro > 15
	aL[13]:=STR0084 //"|          |                  FIRMA                    |                            E N D E R E C O                           |    NOTA     |                 |                                                           |"
	aL[14]:=STR0086 //"|  DATA    |                COMPRADORA                 |----------------------------------------------------------------------|             |    QUANTIDADE   |           P R O D U T O S      V E N D I D O S            |"
	aL[15]:=STR0087 //"|          |                                           |             RUA E NUMERO                |   CEP   |    CIDADE     |UF|   FISCAL    |                 |                                                           |"
	aL[16]:=STR0088 //"|----------+-------------------------------------------+-----------------------------------------+---------+---------------+--+-------------+-----------------+-----------------------------------------------------------|"
	aL[17]:=STR0089 //"|##########|#################### #### #################|#########################################|#########|###############|##|############ |################ | ############################## ###########################|"
	aL[18]:=STR0090 //"|          |                                           |                                         |         |               |  |             |                 |                                                           |"
	aL[19]:=STR0088 //"|----------+-------------------------------------------+-----------------------------------------+---------+---------------+--+-------------+-----------------+-----------------------------------------------------------|"
Else
	aL[13]:=STR0036 //"|            |                    FIRMA                    |                                    E N D E R E C O                           |     NOTA     |                  |                                             |"
	aL[14]:=STR0051 //"|    DATA    |                  COMPRADORA                 |------------------------------------------------------------------------------|              |    QUANTIDADE    |      P R O D U T O S    V E N D I D O S     |"
	aL[15]:=STR0038 //"|            |                                             |               RUA E NUMERO                |    CEP    |     CIDADE      | UF |    FISCAL    |                  |                                             |"
	aL[16]:=STR0039 //"|------------+---------------------------------------------+-------------------------------------------+-----------+-----------------+----+--------------+------------------+---------------------------------------------|"
	aL[17]:=STR0040 //"| ########## | #################### #### ################# | ######################################### | ######### | ############### | ## | ############ | ################ | ############### ########################### |"
	aL[18]:=STR0041 //"|            |                                             |                                           |           |                 |    |              |                  |                                             |"
	aL[19]:=STR0039 //"|------------+---------------------------------------------+-------------------------------------------+-----------+-----------------+----+--------------+------------------+---------------------------------------------|"
EndIf
If nTamCli <= 8 .And. nTamcPro <= 15
	aL[17]:=STR0103 //"|##########|######## #### #############################|#########################################|#########|###############|##|############ |################ | ############################## ###########################|"                                                                                                                                                                                                                                                                                       
EndIf
aL[20]:=STR0027 //"|  OBSERVACOES : FAZER EM (3) TRES VIAS.                                                                                                                                                                                  |"
aL[21]:=STR0028 //"|                ESTE MAPA E APRESENTADO TRIMESTRALMENTE (ATE O DIA 5),                                                                                                                                                   |"
aL[22]:=STR0029 //"|                COM O SALDO DO TRIMESTRE ANTERIOR.                                                                                               ######################### ## DE ############# DE ####                   |"
aL[23]:=STR0030 //"|                RELACAO DE COMPRAS NO VERSO.                                                                                                                                                                             |"
aL[24]:=STR0031 //"|                                                                                                                                                                                                                         |"
aL[25]:=STR0032 //"|                                                                                                                                                  ________________________________________________________               |"
aL[26]:=STR0033 //"|                                                                                                                                                     A S S I N A T U R A   D O   R E S P O N S A V E L                   |"
aL[27]:=STR0031 //"|                                                                                                                                                                                                                         |"
aL[28]:=STR0034 //"|                                                                                                                                                 N O M E ________________________________________________                |"
aL[29]:=STR0031 //"|                                                                                                                                                                                                                         |"
aL[30]:=STR0015 //"|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|"
aL[31]:=STR0042 //"|                                          LICENCAS DE ACIDOS , TRANSPORTE , EXPLOSIVOS , CORROSIVOS                                                                                                                      |"
aL[32]:=STR0043 //"|                                          SFPC/2 - EXERCITO BRASILEIRO                                                                                                                                                   |"
aL[33]:=STR0044 //"|                                          DIRD     - DIVISAO DE PRODUTOS CONTROLADOS                                                                                                                                     |"
aL[34]:=STR0015 //"|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|"
//        1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890
//                 1         2         3         4         5         6         7         8         9        10        11        12        13        14        15        16        17        18        19        20        21        22        
Return (aL)

/*


Ŀ
Funo    R462LExe   Autor Rodrigo de A Sartorio   Data  03.08.04 
Ĵ
Descrio  Lay-Out do Mapa do Exercito                                
Ĵ
Parametros Nenhum                                                     
Ĵ
Retorno    ExpA1 = Array com as strings para a impressao              
Ĵ
 Uso       MATR462                                                    
ٱ


*/
Static Function R462LExe()
Local aL		:= Array(39)
Local nTamCPro	:= TamSX3("B1_COD")[1]
Local nTamForn	:= TamSX3("D1_FORNECE")[1]

aL[01]:=STR0015 //"|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|"
aL[02]:=STR0052 //"| EXMO. SR.                                                                                                                                                                                                               |"
aL[03]:=STR0053 //"| GENERAL COMANDANTE DA ##a. REGIAO MILITAR - SFPC/2 - SAO PAULO                                                                                                                                                          |"
aL[04]:=STR0031 //"|                                                                                                                                                                                                                         |"
aL[05]:=STR0054 //"| A firma  ################################################################# estabelecida a ############################################################### CEP  ########                                                 |"
aL[06]:=STR0055 //"| Fone #################### Fax ################### Bairro ############################# Cidade ############################ portadora do Certificado de Registro No. #################### , valido ate ##########     ,  |"
aL[07]:=STR0056 //"| por seu responsavel que abaixo assina, apresenta a V. Exa., os Mapas do Movimento de produtos controlados referente ao ############ trimestre de #### , de acordo com o regulamento aprovado pelo Decreto No. 3665, de  |"
aL[08]:=STR0057 //"| 20 de novembro de 2000.                                                                                                                                                                                                 |"
aL[09]:=STR0015 //"|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|"
aL[10]:=STR0058 //"| a) Movimento Geral                                                                                                                                                                                                      |"
aL[11]:=STR0015 //"|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|"
If nTamCPro > 15
	aL[12]:=STR0091 //"|                                                              |     SALDO DO     |                  |                  |                  |  VENDAS , PERDAS   |  SALDO QUE PASSA PARA O |  UNIDADES DE                  |"
	aL[13]:=STR0092 //"|                         PRODUTOS                             |     TRIMESTRE    |      COMPRAS     |      SOMA        |     CONSUMO      |  OU TRANSFERENCIAS |    TRIMESTRE SEGUINTE   |  MEDIDAS EM KGS               |"
	aL[14]:=STR0093 //"|                                                              |     ANTERIOR     |                  |                  |                  |                    |                         |                               |"
	aL[15]:=STR0094 //"|--------------------------------------------------------------+------------------+------------------+------------------+------------------+--------------------+-------------------------+-------------------------------|"
	aL[16]:=STR0095 //"| ############################## ##############################| ################ | ################ | ################ | ################ | ################   |    ################     |  ################             |"
	aL[17]:=STR0096 //"|                                                              |                  |                  |                  |                  |                    |                         |                               |"
	aL[18]:=STR0094 //"|--------------------------------------------------------------+------------------+------------------+------------------+------------------+--------------------+-------------------------+-------------------------------|"
Else
	aL[12]:=STR0059 //"|                                               |     SALDO DO     |                  |                  |                  |  VENDAS , PERDAS   |  SALDO QUE PASSA PARA O | UNIDADES DE                                  |"
	aL[13]:=STR0060 //"|                  PRODUTOS                     |     TRIMESTRE    |      COMPRAS     |      SOMA        |     CONSUMO      |  OU TRANSFERENCIAS |    TRIMESTRE SEGUINTE   | MEDIDAS EM KGS                               |"
	aL[14]:=STR0061 //"|                                               |     ANTERIOR     |                  |                  |                  |                    |                         |                                              |"
	aL[15]:=STR0062 //"|-----------------------------------------------+------------------+------------------+------------------+------------------+--------------------+-------------------------+----------------------------------------------|"
	aL[16]:=STR0063 //"| ############### ##############################| ################ | ################ | ################ | ################ | ################   |    ################     |  ################                            |"
	aL[17]:=STR0064 //"|                                               |                  |                  |                  |                  |                    |                         |                                              |"
	aL[18]:=STR0062 //"|-----------------------------------------------+------------------+------------------+------------------+------------------+--------------------+-------------------------+----------------------------------------------|"
EndIf	
aL[19] :=	STR0065 //"| b) Relacao das compras efetuadas no estado de Sao Paulo                                                                                                                                                                 |"
aL[20] :=	STR0015 //"|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|"
If nTamCPro > 15
	aL[21]:=STR0097 //"|          |                   FIRMA                   |    E N D E R E C O   D A   F I R M A   V E N D E D O R A   | GUIA DE  |    NOTA    |                 |                                                           |"
	aL[22]:=STR0098 //"|   DATA   |                 VENDEDORA                 |------------------------------------------------------------| TRAFEGO  |            |   QUANTIDADE    |          P R O D U T O S     C O M P R A D O S            |"
	aL[23]:=STR0099 //"|          |                                           |        RUA , NUMERO E BAIRRO            |    CIDADE     |UF| NUMERO   |   FISCAL   |                 |                                                           |"
	aL[24]:=STR0100 //"|----------+-------------------------------------------+-----------------------------------------+---------------+--+----------+------------+-----------------+-----------------------------------------------------------|"
	aL[25]:=STR0101 //"|##########|#################### #### #################|#########################################|###############|##|##########|############|################ | ############################## ###########################|"
	aL[39]:=STR0083 //"|          |                                           |                                         |               |  |          |            |                 |                                                           |"
Else
	aL[21]:=STR0066 //"|            |                    FIRMA                    |      E N D E R E C O   D A   F I R M A   V E N D E D O R A       |   GUIA DE  |     NOTA     |                  |                                            |"
	aL[22]:=STR0067 //"|    DATA    |                  VENDEDORA                  |------------------------------------------------------------------|   TRAFEGO  |              |    QUANTIDADE    |    P R O D U T O S    C O M P R A D O S    |"
	aL[23]:=STR0068 //"|            |                                             |          RUA , NUMERO E BAIRRO            |     CIDADE      | UF |   NUMERO   |    FISCAL    |                  |                                            |"
	aL[24]:=STR0069 //"|------------+---------------------------------------------+-------------------------------------------+-----------------+----+------------+--------------+------------------+--------------------------------------------|"
	aL[25]:=STR0070 //"| ########## | #################### #### ################# | ######################################### | ############### | ## | ########## | ############ | ################ | ############### ###########################|"
	aL[39]:=STR0076 //"|            |                                             |                                           |                 |    |            |              |                  |                                            |"
EndIf	   
If nTamForn <= 8 .And. nTamCPro <= 15
	aL[25]:=STR0104 //"| ########## | ######## #### ############################# | ######################################### | ############### | ## | ########## | ############ | ################ | ############### ###########################|"                                                                                                                                                                                                                                                                                       
EndIf
aL[26]:=STR0071 //"| c) Relacao das compras efetuadas em outros estados                                                                                                                                                                      |"
aL[27]:=STR0015 //"|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|"
aL[28]:=STR0072 //"| ATENCAO: Prazo improrrogavel para entrega ate o                                                                                                                                                                         |"
aL[29]:=STR0073 //"|          dia 5 apos o vencimento do trimestre.                                                                                                                                                                          |"
aL[30]:=STR0074 //"|                                                                                                                                                 ######################### ## DE ############# DE ####                   |"
aL[31]:=STR0031 //"|                                                                                                                                                                                                                         |"
aL[32]:=STR0031 //"|                                                                                                                                                                                                                         |"
aL[33]:=STR0032 //"|                                                                                                                                                  ________________________________________________________               |"
aL[34]:=STR0033 //"|                                                                                                                                                     A S S I N A T U R A   D O   R E S P O N S A V E L                   |"
aL[35]:=STR0031 //"|                                                                                                                                                                                                                         |"
aL[36]:=STR0075 //"| Obs: Fazer em 4 vias                                                                                                                            N O M E ________________________________________________                |"
aL[37]:=STR0031 //"|                                                                                                                                                                                                                         |"
aL[38]:=STR0015 //"|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|"
Return (aL)

/*


Ŀ
Funo    R462Cabec()    AutorRodrigo A Sartorio   Data  04.08.04 
Ĵ
Descrio Cabecalho do Relatorio                                      
Ĵ
Parametros ExpN1 = No.da linha                                        
           ExpC1 = Tipo do relatorio                                  
           ExpA1 = Array com descricao ordinal dos Trimestres	      
           ExpA2 = Array com strings para impressao	                  
Ĵ
Retorno    Nenhum                                                     
Ĵ
 Uso       MATR462                                                    
ٱ


*/
Static Function R462Cabec(nLin,nTipo,aMesOrd,aL)
Local cPicCgc
If  cPaisLoc=="ARG"
	cPicCgc	:="@R 99-99.999.999-9"
ElseIf cPaisLoc == "CHI"
	cPicCgc	:="@R XX.999.999-X"
ElseIf cPaisLoc $ "POR|EUA"
	cPicCgc	:=PesqPict("SA2","A2_CGC")
Else
	cPicCgc	:="@R 99.999.999/9999-99"
EndIf

// Inicio da Capa do Mapa de Compras e Capa e Interior do Mapa de Vendas
If nTipo == 1 .Or. nTipo == 5 .Or. nTipo == 6
	nLin:=1
	@ 00,00 PSAY AvalImp(220)
	If nTipo == 1 .Or. nTipo == 5
		FmtLin(,aL[01],,,@nLin)
		FmtLin(,aL[02],,,@nLin)
		FmtLin(,aL[03],,,@nLin)
		FmtLin(,aL[04],,,@nLin)
		FmtLin({aMesOrd[mv_par09],Str(Year(dDataBase),4,0)},aL[05],,,@nLin)
		FmtLin(,aL[06],,,@nLin)
		FmtLin({SM0->M0_NOMECOM,InscrEst()},aL[07],,,@nLin)
		FmtLin({SM0->M0_ENDCOB,Transform(SM0->M0_CGC,cPicCgc)},aL[08],,,@nLin)
		FmtLin({SM0->M0_CIDCOB,SM0->M0_CEPCOB},aL[09],,,@nLin)
		FmtLin({SM0->M0_TEL},aL[10],,,@nLin)
		FmtLin(,aL[11],,,@nLin)
	EndIf
	FmtLin(,aL[12],,,@nLin)
	FmtLin(,aL[13],,,@nLin)
	FmtLin(,aL[14],,,@nLin)
	FmtLin(,aL[15],,,@nLin)
	FmtLin(,aL[16],,,@nLin)
// Fim da Capa do Mapa de Compras / Fim da capa do Mapa de Vendas
ElseIf nTipo == 2 .Or. nTipo == 7
	FmtLin(,aL[19],,,@nLin)
	FmtLin(,aL[20],,,@nLin)
	FmtLin(,aL[21],,,@nLin)
	FmtLin({SM0->M0_CIDCOB,StrZero(Day(dDataBase),2,0),MesExtenso(Month(dDataBase)),Str(Year(dDataBase),4,0)},aL[22],,,@nLin)
	FmtLin(,aL[23],,,@nLin)
	FmtLin(,aL[24],,,@nLin)
	FmtLin(,aL[25],,,@nLin)
	FmtLin(,aL[26],,,@nLin)
	FmtLin(,aL[27],,,@nLin)
	FmtLin(,aL[28],,,@nLin)	
	FmtLin(,aL[29],,,@nLin)
	FmtLin(,aL[30],,,@nLin)	
	nLin:=80
// Inicio do interior do Mapa de Compras
ElseIf nTipo == 3
	nLin:=1
	@ 00,00 PSAY AvalImp(220)
	FmtLin(,aL[30],,,@nLin)
	FmtLin(,aL[31],,,@nLin)
	FmtLin(,aL[32],,,@nLin)
	FmtLin(,aL[33],,,@nLin)
	FmtLin(,aL[34],,,@nLin)
	FmtLin(,aL[35],,,@nLin)
	FmtLin(,aL[36],,,@nLin)
// Fim do interior do Mapa de Compras
ElseIf nTipo == 4
	FmtLin(,aL[40],,,@nLin)
	FmtLin(,aL[41],,,@nLin)
	FmtLin(,aL[42],,,@nLin)
	FmtLin(,aL[43],,,@nLin)
	FmtLin(,aL[44],,,@nLin)
	nLin:=80
// Fim do interior do Mapa de Vendas
ElseIf nTipo == 8
	FmtLin(,aL[30],,,@nLin)
	FmtLin(,aL[31],,,@nLin)
	FmtLin(,aL[32],,,@nLin)
	FmtLin(,aL[33],,,@nLin)
	FmtLin(,aL[34],,,@nLin)
	nLin:=80
// Inicio do mapa do exercito
ElseIf nTipo == 9 .Or. nTipo == 11
	nLin:=1
	@ 00,00 PSAY AvalImp(220)
	If nTipo == 9
		FmtLin(,aL[01],,,@nLin)
		FmtLin(,aL[02],,,@nLin)
		FmtLin({Str(mv_par13,2)},aL[03],,,@nLin)	
		FmtLin(,aL[04],,,@nLin)
		FmtLin({SM0->M0_NOMECOM,SM0->M0_ENDCOB,SM0->M0_CEPCOB},aL[05],,,@nLin)
		FmtLin({SM0->M0_TEL,SM0->M0_FAX,SM0->M0_BAIRCOB,SM0->M0_CIDCOB,mv_par14,DTOC(mv_par15)},aL[06],,,@nLin)		
		FmtLin({aMesOrd[mv_par09],Str(Year(dDataBase),4,0)},aL[07],,,@nLin)
		FmtLin(,aL[08],,,@nLin)	
	EndIf	
	FmtLin(,aL[09],,,@nLin)	
	FmtLin(,aL[10],,,@nLin)	
	FmtLin(,aL[11],,,@nLin)	
	FmtLin(,aL[12],,,@nLin)	
	FmtLin(,aL[13],,,@nLin)	
	FmtLin(,aL[14],,,@nLin)	
	FmtLin(,aL[15],,,@nLin)	
// Fim da capa do mapa do exercito
ElseIf	nTipo == 10
	FmtLin(,aL[27],,,@nLin)
	FmtLin(,aL[28],,,@nLin)
	FmtLin(,aL[29],,,@nLin)
	FmtLin({SM0->M0_CIDCOB,StrZero(Day(dDataBase),2,0),MesExtenso(Month(dDataBase)),Str(Year(dDataBase),4,0)},aL[30],,,@nLin)
	FmtLin(,aL[31],,,@nLin)
	FmtLin(,aL[32],,,@nLin)
	FmtLin(,aL[33],,,@nLin)
	FmtLin(,aL[34],,,@nLin)
	FmtLin(,aL[35],,,@nLin)
	FmtLin(,aL[36],,,@nLin)	
	FmtLin(,aL[37],,,@nLin)
	FmtLin(,aL[38],,,@nLin)	
	nLin:=80
ElseIf nTipo == 12
	nLin:=1
	@ 00,00 PSAY AvalImp(220)
	FmtLin(,aL[20],,,@nLin)
	FmtLin(,aL[19],,,@nLin)	
	FmtLin(,aL[20],,,@nLin)	
	FmtLin(,aL[21],,,@nLin)	
	FmtLin(,aL[22],,,@nLin)	
	FmtLin(,aL[23],,,@nLin)	
	FmtLin(,aL[24],,,@nLin)	
ElseIf nTipo == 13 .Or. nTipo == 14
	If nTipo == 14
		nLin:=1
		@ 00,00 PSAY AvalImp(220)
	EndIf
	FmtLin(,aL[20],,,@nLin)
	FmtLin(,aL[26],,,@nLin)	
	FmtLin(,aL[27],,,@nLin)	
	FmtLin(,aL[21],,,@nLin)	
	FmtLin(,aL[22],,,@nLin)	
	FmtLin(,aL[23],,,@nLin)	
	FmtLin(,aL[24],,,@nLin)	
EndIf
Return (NIL)
