#INCLUDE 'MATR903.CH'

/*/


Ŀ
Funo     MATR903   Autor  Ricardo Berti          Data  22.06.06 
Ĵ
Descrio  Relacao de produtos com problema na baixa FIFO             
Ĵ
Sintaxe    MATR903()			                                      
Ĵ
Retorno    Nenhum		                                              
Ĵ
Uso        Generico                                                   
ٱ


/*/
Function MATR903()

Local oReport

If !(FindFunction("MATA330_V")	.And. MATA330_V() >= 20091201)
	Final(OemToAnsi(STR0010))
EndIf

If FindFunction("TRepInUse") .And. TRepInUse()
	//Ŀ
	//Interface de impressao                                                  
	//
	oReport := ReportDef()
	oReport:PrintDialog()
Else
	MATR903R3()
EndIf

Return


/*/


Ŀ
Programa  ReportDef  Autor  Ricardo Berti 		 Data 22.06.2006
Ĵ
Descrio A funcao estatica ReportDef devera ser criada para todos os 
          relatorios que poderao ser agendados pelo usuario.          
                                                                      
Ĵ
Retorno   ExpO1: Objeto do relatorio                                  
Ĵ
ParametrosNenhum                                                      
                                                                      
Ĵ
 Uso       MATR903                                                    
ٱ


/*/
Static Function ReportDef()

Local oReport 
Local oSection 
Local cCell         
Local oCell         

//Ŀ
//Criacao do componente de impressao                                      
//                                                                        
//TReport():New                                                           
//ExpC1 : Nome do relatorio                                               
//ExpC2 : Titulo                                                          
//ExpC3 : Pergunte                                                        
//ExpB4 : Bloco de codigo que sera executado na confirmacao da impressao  
//ExpC5 : Descricao                                                       
//
oReport := TReport():New("MATR903",STR0001,/*cPerg*/, {|oReport| ReportPrint(oReport)},STR0002+" "+STR0003)//'RELACAO DE PRODUTOS COM PROBLEMAS NA BAIXA"##"O objetivo deste relatorio e exibir detalhadamente todos os produtos com"##"problemas na baixa quando do processamento do custo FIFO.

oSection := TRSection():New(oReport,STR0009,{"TRB"}) //"Produtos"
oSection:SetHeaderPage()

oCell := TRCell():New(oSection,"TRB_COD","TRB",/*Titulo*/,/*Picture*/,/*Tamanho*/,/*lPixel*/,/*{|| code-block de impressao }*/)
oCell:GetFieldInfo("D8_PRODUTO")

oCell := TRCell():New(oSection,"TRB_LOCAL","TRB")
oCell:GetFieldInfo("D8_LOCAL")

oCell := TRCell():New(oSection,"TRB_DESC","TRB")
oCell:GetFieldInfo("B1_DESC")
oCell:SetSize(25)

cCell := Posicione("SX3",2,"D8_QUANT","X3TITULO()")
TRCell():New(oSection,"TRB_QUANT","TRB",cCell,PesqPict("SD8","D8_QUANT"),,,{|| Val(TRB_QUANT) })

oCell := TRCell():New(oSection,"TRB_CF","TRB")
oCell:GetFieldInfo("D8_CF")
oCell := TRCell():New(oSection,"TRB_TM","TRB")
oCell:GetFieldInfo("D8_TM")
oCell := TRCell():New(oSection,"TRB_DOC","TRB")
oCell:GetFieldInfo("D8_DOC")
oCell := TRCell():New(oSection,"TRB_SERIE","TRB")
oCell:GetFieldInfo("D8_SERIE")
oCell := TRCell():New(oSection,"TRB_OP","TRB")
oCell:GetFieldInfo("D8_OP")

cCell := Posicione("SX3",2,"D2_EMISSAO","X3TITULO()")
TRCell():New(oSection,"TRB_DTBASE","TRB",cCell,,8)

Return(oReport)


/*/


Ŀ
Programa  ReportPrin Autor  Ricardo Berti 		 Data 22.06.2006
Ĵ
Descrio A funcao estatica ReportDef devera ser criada para todos os 
          relatorios que poderao ser agendados pelo usuario.          
                                                                      
Ĵ
Retorno   Nenhum                                                      
Ĵ
ParametrosExpO1: Objeto Report do Relatorio                           
                                                                      
Ĵ
   DATA    Programador   Manutencao efetuada                         
Ĵ
                                                                     
ٱ


/*/
Static Function ReportPrint(oReport)

Local aCampos	:= {}
Local cArqDif	:= "LOGDIF"+cEmpAnt+cFilAnt+".TXT"
Local cNomTrb	:= ''
Local cNomTrb1	:= ''

//Ŀ
// Cria arquivo de trabalho para processar pela sequencia.           
//
AADD(aCampos,{ "TRB_FILIAL"	    ,"C",02,0 } )
AADD(aCampos,{ "TRB_COD"	    ,"C",15,0 } )
AADD(aCampos,{ "TRB_LOCAL"	    ,"C",02,0 } )
AADD(aCampos,{ "TRB_DESC"	    ,"C",25,0 } )
AADD(aCampos,{ "TRB_QUANT"		,"C",16,0 } )
AADD(aCampos,{ "TRB_CF"			,"C",03,0 } )
AADD(aCampos,{ "TRB_TM"			,"C",03,0 } )
AADD(aCampos,{ "TRB_DOC"		,"C",06,0 } )
AADD(aCampos,{ "TRB_SERIE"		,"C",03,0 } )
AADD(aCampos,{ "TRB_OP"			,"C",13,0 } )
AADD(aCampos,{ "TRB_DTBASE"	    ,"C",08,0 } )

cNomTrb  := CriaTrab(aCampos)
cNomTrb1 := Subs(cNomTrb,1,7)+"A"
dbSelectArea(0)
dbUseArea( .T.,,cNomTrb,"TRB",.F. )
dbSelectArea("TRB")
Zap

If File(cArqDif)
	Append From (cArqDif) SDF
Endif
dbGoTop()

IndRegua("TRB",cNomTrb1,"TRB->TRB_FILIAL+TRB->TRB_COD+TRB->TRB_LOCAL+TRB->TRB_OP+TRB->TRB_DTBASE",,,STR0007 )  //"Criando Arquivo Trabalho 1..."

#IFNDEF TOP
	dbSetIndex(cNomTrb1+OrdBagExt())
#ENDIF

oReport:Section(1):Print()

//Ŀ
// Deleta Arquivo de Trabalho (TRB)                                  
//
dbSelectarea("TRB")
dbCloseArea()
Ferase(cNomTrb  + GetDBExtension())  // Arquivo de trabalho
Ferase(cNomTrb1 + OrdBagExt()) 		 // Indice gerado 1

Return NIL



/*


Ŀ
Funo     MATR903R3 Autor  Patricia A. Salomao    Data 13.06.2000
Ĵ
Descrio  Relacao de produtos com problema na baixa FIFO             
Ĵ
 Uso       Generico                                                   
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
                                                                    
ٱ

*/

Function MATR903R3()

//Ŀ
// Define Variaveis Locais                                      
//
Local cDesc1     := OemToAnsi(STR0002) //"Este relatrio tem por objetivo mostrar as movimentaes que tenham problemas"
Local cDesc2     := OemToAnsi(STR0003) //"com a baixa pelo mtodo de custo FIFO, conforme parametrizao do usurio."
Local cDesc3     := ''
Local cString    := 'SD8'
Local lEnd       := .F.
Local Tamanho    := 'M'
Local Titulo     := OemToAnsi(STR0001) //'RELACAO DE PRODUTOS COM PROBLEMAS NA BAIXA" 
Local wnRel      := 'MATR903'
Private nLastKey   := 0
Private aReturn  := {OemToAnsi(STR0004), 1, OemToAnsi(STR0005), 2, 2, 1, '', 1} //'Zebrado'###'Administrao'

//Ŀ
// Envia controle para a funcao SETPRINT                        
//
wnRel := SetPrint(cString, wnRel,/*cPerg*/, Titulo, cDesc1, cDesc2, cDesc3, .F.,, .F., Tamanho)

If nLastKey == 27
	Set Filter To
	Return Nil
Endif

SetDefault(aReturn, cString)

If nLastKey == 27
	Set Filter To
	Return Nil
Endif

RptStatus({|lEnd| C903Imp(@lEnd, wnRel, Tamanho, Titulo)}, Titulo)

Set Filter To

Return Nil


/*


Ŀ
Funo     C903Imp   Autor  Patricia A. Salomao    Data 13.06.2000
Ĵ
Descrio   Relacao de produtos com problema na baixa FIFO            
Ĵ
 Uso       Generico                                                   
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
                                                                    
ٱ

*/
Static Function C903Imp(lEnd, wnRel, Tamanho, Titulo)

Local nTipo      := 0
Local aCampos    := {}
Local lMovimento :=.F.
Local cArqDif := "LOGDIF"+cEmpAnt+cFilAnt+".TXT"
Local cNomTrb  := ''
Local cNomTrb1 := ''

//Ŀ
// Variaveis utilizadas para Impressao do Cabecalho e Rodape         
//

Private cbTxt   := SPACE(10)
Private cbCont  := 0
Private Li      := 80
Private M_pag   := 1

Private cabec1 := OemToAnsi(STR0006) // " PRODUTO          LOCAL  DESCRICAO                    QUANTIDADE  COD. FISCAL  TPO MOVTO.    DOC.   SER  ORDEM PRODUCAO  DT EMISSAO"
Private cabec2 := ""
// PRODUTO          LOCAL  DESCRICAO                    QUANTIDADE  COD. FISCAL  TPO MOVTO.    DOC.   SER  ORDEM PRODUCAO  DT EMISSAO
// 123456789012345   99    1234567890123456789012345  9.999.999,99      999         999       999999  999     99999999999   99/99/99

//Ŀ
//Inicializa os codigos de caracter Comprimido/Normal da impressora  
//

nTipo := IIF(aReturn[4]==1,GetMV("MV_COMP"),GetMV("MV_NORM"))

//Ŀ
// Cria arquivo de trabalho para processar pela sequencia.           
//

AADD(aCampos,{ "TRB_FILIAL"	    ,"C",02,0 } )
AADD(aCampos,{ "TRB_COD"	    ,"C",15,0 } )
AADD(aCampos,{ "TRB_LOCAL"	    ,"C",02,0 } )
AADD(aCampos,{ "TRB_DESC"	    ,"C",25,0 } )
AADD(aCampos,{ "TRB_QUANT"		,"C",16,0 } )
AADD(aCampos,{ "TRB_CF"			,"C",03,0 } )
AADD(aCampos,{ "TRB_TM"			,"C",03,0 } )
AADD(aCampos,{ "TRB_DOC"		,"C",06,0 } )
AADD(aCampos,{ "TRB_SERIE"		,"C",03,0 } )
AADD(aCampos,{ "TRB_OP"			,"C",13,0 } )
AADD(aCampos,{ "TRB_DTBASE"	    ,"C",08,0 } )

cNomTrb  := CriaTrab(aCampos)
cNomTrb1 := Subs(cNomTrb,1,7)+"A"
dbSelectArea(0)
dbUseArea( .T.,,cNomTrb,"TRB",.F. )
dbSelectArea("TRB")
Zap

If File(cArqDif)
	Append From (cArqDif) SDF
Endif
dbGoTop()

IndRegua("TRB",cNomTrb1,"TRB->TRB_FILIAL+TRB->TRB_COD+TRB->TRB_LOCAL+TRB->TRB_OP+TRB->TRB_DTBASE",,,OemToAnsi(STR0007) )  //"Criando Arquivo Trabalho 1..."

#IFNDEF TOP
  dbSetIndex(cNomTrb1+OrdBagExt())
#ENDIF

dbGoTop()

SetRegua(LastRec())

While !Eof()

    //Ŀ
    //Verifica se houve interrupcao pelo operador                                                                         
    //
	
	If lEnd
		@Prow()+1,001 PSAY OemToAnsi(STR0008) // "CANCELADO PELO OPERADOR"
 		Exit
	Endif

	lMovimento:=.T.
	IncRegua()

	If li > 58
		Cabec(titulo,cabec1,cabec2,wnRel,Tamanho,nTipo)
	EndIf

	@ Li,002 PSAY TRB->TRB_COD
	@ Li,019 PSAY TRB->TRB_LOCAL
	@ Li,025 PSAY TRB->TRB_DESC
	@ Li,052 PSAY Val(TRB->TRB_QUANT) Picture PesqPict("SD8","D8_QUANT")
	@ Li,070 PSAY TRB->TRB_CF
	@ Li,082 PSAY TRB->TRB_TM
	@ Li,092 PSAY TRB->TRB_DOC
	@ Li,100 PSAY TRB->TRB_SERIE
	@ Li,108 PSAY TRB->TRB_OP
	@ Li,122 PSAY TRB->TRB_DTBASE
	Li:= Li+1
	dbSkip()
	If li > 58
		Cabec(titulo,cabec1,cabec2,wnRel,tamanho,nTipo)
	EndIf
End

If lMovimento
	Roda(cbcont,cbtxt,Tamanho)
EndIf

//Ŀ
// Deleta Arquivo de Trabalho (TRB)                                  
//

dbSelectarea("TRB")
dbCloseArea()
Ferase(cNomTrb  + GetDBExtension())       // Arquivo de trabalho
Ferase(cNomTrb1 + OrdBagExt())  // Indice gerado 1

//Ŀ
// Devolve a condicao original do arquivo principal                  
//

dbSelectArea("SB1")
dbSetOrder(1)

Set device to Screen

If aReturn[5] == 1
	Set Printer To
	dbCommitAll()
	OurSpool(wnrel)
Endif

MS_FLUSH()

Return
