#INCLUDE "rwmake.ch"

/*/


ͻ
Programa  AGRR105    Autor  Saulo Carvalho Gomes Data   01/11/05  
͹
Descricao  Relao de contratos financeiros                           
                                                                      
͹
Uso        Clientes Microsiga                                         
ͼ


/*/

Function AgrR105

Local cDesc1         := "Este programa tem como objetivo imprimir relatorio "
Local cDesc2         := "de acordo com os parametros informados pelo usuario."
Local cDesc3         := "Contrato Financeiro"
Local cPict          := ""
Local titulo         := "Contrato Financeiro"
Local nLin           := 80
Local Cabec1         := ""
Local Cabec2         := ""
Local imprime        := .T.

Private aOrd        := {}
Private lEnd        := .F.
Private lAbortPrint := .F.
Private limite      := 132
Private tamanho     := "M"
Private nomeprog    := 'AGRR105'
Private nTipo       := 18
Private aReturn     := { "Zebrado", 1, "Administracao", 1, 2, 1, "", 1}
Private nLastKey    := 0
Private cbtxt       := Space(10)
Private cbcont      := 00
Private CONTFL      := 01
Private m_pag       := 01
Private cPerg       := "AGR105"
Private wnrel       := "AGRR105"

Private cString := "NO7"

dbSelectArea("NO7")
dbSetOrder(1)

AjustaSX1()

Pergunte(cPerg,.F.)

wnrel := SetPrint(cString,NomeProg,cPerg,@titulo,cDesc1,cDesc2,cDesc3,.F.,,.F.,Tamanho,,.F.)

If nLastKey == 27
	Return
Endif

SetDefault(aReturn,cString)

If nLastKey == 27
   Return
Endif

nTipo := If(aReturn[4]==1,15,18)


RptStatus({|| RunReport(Cabec1,Cabec2,Titulo,nLin) },Titulo)
Return

/*/


ͻ
Funo    RUNREPORT  Autor  AP6 IDE             Data   01/10/04   
͹
Descrio  Funcao auxiliar chamada pela RPTSTATUS. A funcao RPTSTATUS 
           monta a janela com a regua de processamento.               
͹
Uso        Programa principal                                         
ͼ


/*/                                             

Static Function RunReport(Cabec1,Cabec2,Titulo,nLin)
//Local aArea   := GetArea()
Local cCodAnt := ""
Local cGrupo  := ""
Local cDesc   := ""
Local cCabDet := ""
Local cTipo   := ""
Local cAditivo:= ""

//Variveis para criao de filtro
Local cIndex  := ""
Local cChave  := ""
Local cFiltro := ""
Local cFilSE2 := ""
Local cTipSE2 := ""

//Variveis para clculo
Local nPRAb	  := 0
Local nPRBx   := 0
Local nJRAb	  := 0
Local nJRBx   := 0
Local nTotFor := 0

dbSelectArea(cString)
dbGoTop()

cFiltro := "NO7_CODFOR >= '"+MV_PAR01+"' .And. "
cFiltro += "NO7_CODFOR <= '"+MV_PAR02+"' .And. "
If (MV_PAR03 <> 3)
	If (MV_PAR03 = 1)
		cTipo 	:= "PR"
		cFiltro += "NO7_TIPO  == '"+ cTipo+"' .And. "
	Else
		cTipo 	:= "JR"
		cFiltro += "NO7_TIPO  == '"+ cTipo+"' .And. "
	EndIf
EndIf
cFiltro += "DTOS(NO7_DATEMI) >= '"+DTOS(MV_PAR04)+"' .And. "
cFiltro += "DTOS(NO7_DATEMI) <= '"+DTOS(MV_PAR05)+"' .And. "
cFiltro += "NO7_NUMERO >= '"+MV_PAR06+"' .And. "
cFiltro += "NO7_NUMERO <= '"+MV_PAR07+"'"

dbSelectArea("NO7")
dbSetOrder(1)
cIndex	:= CriaTrab(nil,.f.)
cChave	:= IndexKey()
IndRegua("NO7",cIndex,cChave,,cFiltro,"Selecionando Registros...")
nIndex := RetIndex("NO7")
DbSelectArea("NO7")
#IFNDEF TOP
	DbSetIndex(cIndex+OrdBagExt())
#ENDIF
DbSetOrder(nIndex+1)
dbGotop()

		 //          0         0         0         0         0         0         0         0         0         1         1         1         1
		 //          1         2         3         4         5         6         7         8         9         0         1         2         3
		 //012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901
Cabec1 := "  Fornecedor"
Cabec2 := "  No. Contrato  No. Completo          Adit  Tipo  Data Emi    Valor"
cCabDet:= "  Pref  Num     Parc  Tipo  Vencto    Valor           Status "

cCodAnt := NO7_NUMERO
cTipo   := NO7_TIPO
cAditivo:= NO7_ADTIVO
cGrupo  := NO7_CODFOR

While .Not. Eof()
	If MV_PAR03 == 1 .AND. NO7_TIPO == 'JR'
		dbSkip()
		Loop
	ElseIf MV_PAR03 == 2 .AND. NO7_TIPO == 'PR'
		dbSkip()
		Loop
	EndIf
	If cAditivo < fUltAdt(NO7->NO7_NUMERO, NO7->NO7_TIPO, NO7->NO7_ADTIVO)
		dbSkip()
		Loop
	EndIf

   If lAbortPrint
      @nLin,00 PSAY "*** CANCELADO PELO OPERADOR ***"
      Exit
   Endif

   If nLin > 55 // Salto de Pgina. Neste caso o formulario tem 55 linhas...
      If nLin < 80
	  	Roda()
	  EndIf
      Cabec(Titulo,Cabec1,Cabec2,NomeProg,Tamanho,nTipo)
      nLin := 9
   Endif  

   If (NO7_NUMERO	<> cCodAnt)
	  Cabec(Titulo,Cabec1,Cabec2,NomeProg,Tamanho,nTipo)
      nLin := 9        
   	  cCodAnt	:= NO7_NUMERO
      cTipo  	:= NO7_TIPO
      cAditivo	:= NO7_ADTIVO
      If  cGrupo <> NO7_CODFOR
      	nTotFor := 0  
      EndIf         
   EndIf

   dbSelectArea("SA2")
   dbSetOrder(1)
   If DbSeek(XFilial("SA1")+NO7->NO7_CODFOR + NO7->NO7_LOJFOR)
		cDesc := AllTrim(A2_NOME)
   EndIf

   dbSelectArea("NO7")
   cTipo    := NO7_TIPO
   //cAditivo := NO7_ADTIVO

   @ nLin , 002 PSay PadR(AllTrim(NO7_CODFOR) + "-" + AllTrim(NO7_LOJFOR),9) 
   @ nLin , 013 PSay PadR(cDesc,30)
   nLin ++
   @ nLin , 002 PSay PadR(NO7_NUMERO,06)
   @ nLin , 016 PSay PadR(NO7_NUMCMP,20)
   @ nLin , 038 PSay PadR(NO7_ADTIVO,01) 
   @ nLin , 044 PSay PadR(NO7_TIPO,02)
   @ nLin , 050 PSay NO7_DATEMI
   @ nLin , 062 PSay Transform(NO7_VALOR ,"@E 999,999,999.99")
   nLin ++
   @ nLin , 002 PSay "Historico: " + PadR(NO7_HISTOR,75)		
   nLin := nLin + 2
   @ nLin, 002 PSay Replicate("-",130)
   nLin ++

	cTipSE2 := IIf(NO7->NO7_TIPO = 'JR','JP','DP')

	cFilSE2 := "E2_NUM = '"+NO7->NO7_NUMERO+"' .And. AllTrim(E2_TIPO) = '"+CTipSE2+"' .And."
	cFilSE2 += "E2_PREFIXO = '"+('CT'+AllTrim(NO7->NO7_ADTIVO))+"'"
	dbSelectArea("SE2")
	dbSetOrder(1)//E2_FILIAL+E2_PREFIXO+E2_NUM+E2_PARCELA+E2_TIPO+E2_FORNECE+E2_LOJA
	dbSetFilter( {|| &cFilSE2 }, cFilSE2 )
	dbGotop()

	@ nLin, 000 PSay cCabDet
	nLin += 2

	While .Not. Eof()

       	@ nLin, 002 PSay PadR(SE2->E2_PREFIXO,3)
		@ nLin, 008 PSay PadR(SE2->E2_NUM,6)
		@ nLin, 016 PSay PadR(SE2->E2_PARCELA,1)
		@ nLin, 022 PSay PadR(SE2->E2_TIPO,2)
		@ nLin, 028 PSay DToC(SE2->E2_VENCTO)
		@ nLin, 038 PSay Transform(SE2->E2_VALOR,"@E 999,999,999.99")
		If (SE2->E2_VALOR == SE2->E2_SALDO)
			@ nLin, 054 PSay "Aberto"
			If (NO7->NO7_TIPO = "PR")
				nPRAb	:= nPRAb + SE2->E2_VALOR
			Else
				nJRAb	:= nJRAb + SE2->E2_VALOR
			EndIf
		ElseIf (SE2->E2_VALOR > SE2->E2_SALDO)
			@ nLin, 054 PSay "Baixado"
			If (NO7->NO7_TIPO = "PR")
				nPRBx	:= nPRBx + (SE2->E2_VALOR-SE2->E2_SALDO)
			Else
				nJRBx	:= nJRBx + (SE2->E2_VALOR-SE2->E2_SALDO)
			EndIf
		EndIf
		nTotFor := nTotFor + SE2->E2_VALOR
    	nLin++
    	dbSelectArea('SE2')
		dbSkip()
	EndDo

	SE2->(dbClearFilter())

	@ nLin, 002 PSay Replicate("-",130)
	nLin ++
    If (cTipo == "PR")
		@ nLin, 002 PSay "Total Aberto Principal: " 
		@ nLin, 027 PSay  Transform(nPRAb,"@E 999,999,999.99")
		@ nLin, 044 PSay "Total Baixado Principal: " 
		@ nLin, 070 PSay Transform(nPRBx,"@E 999,999,999.99") 
		nLin ++
	ElseIf (cTipo == "JR")
		@ nLin, 002 PSay "Total Aberto Juros: " 
		@ nLin, 027 PSay  Transform(nJRAb,"@E 999,999,999.99")
		@ nLin, 044 PSay "Total Baixado Juros: " 
		@ nLin, 070 PSay Transform(nJRBx,"@E 999,999,999.99") 
		nLin ++
	EndIf
	@ nLin, 002 PSay Replicate("-",130)
	nLin ++; nLin ++; nLin++

	//Zera variaveis
	nPRAb := 0
	nPRBx := 0
	nJRAb := 0
	nJRBx := 0

	dbSelectArea("NO7")
	dbSkip()

	If  cGrupo <> NO7_CODFOR
		@ nLin, 002 PSay Replicate("-",130)
		nLin ++
		@ nLin, 002 PSay "Total do Fornecedor : "
		@ nLin, 026 PSay Transform(nTotFor, "@E 999,999,999.99")
		nLin ++
		@ nLin, 002 PSay Replicate("-",130)
		nLin ++
		nTotFor := 0
	EndIf
EndDo

Roda()

SET DEVICE TO SCREEN

If aReturn[5]==1
   dbCommitAll()
   SET PRINTER TO
   OurSpool(wnrel)
Endif

MS_FLUSH()

Return


/*
+--------+--------------------------------------------------------------+
| Funcao | fUltAdt()                                                    |
| Autor  | Ricardo Tomasi                                               |
| Data   | 10 de Maio 2004                                              |
| Descri | Procura ultimo aditivo do contrato.                          |
+--------+--------------------------------------------------------------+
*/
Static Function fUltAdt(cNumero, cTipo, cAdtivo)
Local aAreaNO7 := NO7->(GetArea())
Local cUltAdt  := ''

dbSelectArea('NO7') //NO7_FILIAL+NO7_NUMERO+NO7_ADTIVO+NO7_TIPO
dbGoTop()
While .Not. Eof() .And. NO7->NO7_NUMERO = cNumero
	If NO7->NO7_TIPO = cTipo
		If cAdtivo < NO7->NO7_ADTIVO
			cUltAdt := NO7->NO7_ADTIVO
		EndIf
	EndIf
	dbSkip()
EndDo

RestArea(aAreaNO7)
Return(cUltAdt)


/*
+--------+--------------------------------------------------------------+
| Funcao | AjustaSX1()                                                  |
| Autor  | Ricardo Tomasi                                               |
| Data   | 10 de Maio 2004                                              |
| Descri | Ajusta dicionario de perguntas.                              |
+--------+--------------------------------------------------------------+
*/
Static Function AjustaSX1()
Local sAlias    := Alias()
Local cPergunta := PADR(cPerg,6)
Local nTamSX1   := Len(SX1->X1_GRUPO)
Local aRegs:={}
Local i
Local j

dbSelectArea("SX1")
dbSetOrder(1)

Aadd( aRegs,{ cPergunta, "01",OemToAnsi(PadR("Fornecedor De",19)+"?") ,"","","mv_cha","C", 6 ,0,0,"G","","mv_par01","","","","","","","","","","","","","","","","","","","","","","","","","SA2","" } )
Aadd( aRegs,{ cPergunta, "02",OemToAnsi(PadR("Fornecedor Ate",19)+"?"),"","","mv_chb","C", 6 ,0,0,"G","","mv_par02","","","","","","","","","","","","","","","","","","","","","","","","","SA2","" } )
Aadd( aRegs,{ cPergunta, "03",OemToAnsi(PadR("Tipo",19)+"?")    ,"","","mv_chc","N", 1 ,0,0,"C","","mv_par03","Principal","","","","","Juros","","","","","Ambos","","","","","","","","","","","","","","","" } )
Aadd( aRegs,{ cPergunta, "04",OemToAnsi(PadR("Data de Emisso De",19)+"?")    ,"","","mv_chd","D", 8 ,0,0,"G","","mv_par04","","","","","","","","","","","","","","","","","","","","","","","","","","" } )
Aadd( aRegs,{ cPergunta, "05",OemToAnsi(PadR("Data de Emisso Ate",19)+"?")   ,"","","mv_che","D", 8 ,0,0,"G","","mv_par05","","","","","","","","","","","","","","","","","","","","","","","","","","" } )
Aadd( aRegs,{ cPergunta, "06",OemToAnsi(PadR("Nmero De",19)+"?")    ,"","","mv_chf","C", 6 ,0,0,"G","","mv_par06","","","",""  ,"","","","","","","","","","","","","","","","","","","","","","" } )
Aadd( aRegs,{ cPergunta, "07",OemToAnsi(PadR("Nmero Ate",19)+"?")   ,"","","mv_chg","C", 6 ,0,0,"G","","mv_par07","","","","","","","","","","","","","","","","","","","","","","","","","","" } )

For i:=1 to Len(aRegs)
	If !dbSeek(PADR(cPerg,nTamSX1)+aRegs[i,2])
		RecLock("SX1",.T.)
		For j:=1 to FCount()
			If j <= Len(aRegs[i])
				FieldPut(j,aRegs[i,j])
			Endif
		Next
		MsUnlock()
	Endif
Next

dbSelectArea(sAlias)

Return