#ifdef SPANISH
	#define STR0001 "Registro de calculo de IPI "
	#define STR0002 "Este programa imprimira el Libro de registro de calculo de IPI (modelo P8)   "
	#define STR0003 "de acuerdo con los parametros y el periodo informado."
	#define STR0004 "A Rayas"
	#define STR0005 "Administrac. "
	#define STR0006 "SIN MOVIMIENTO"
	#define STR0007 "|                                                    REGISTRO DE CALCULO DEL IPI                                                   |"
	#define STR0008 "|                                                INFORME DE CALCULO DEL IMPUESTO                                                   |"
	#define STR0009 "| FIRMA: #########################################################                                                                 |"
	#define STR0010 "| INSC.EST.: ######################## CNPJ.: #################                                                                  |"
	#define STR0011 "| PLAN.: ####     MES O PERIODO/ANO : #######                                                                                      |"
	#define STR0012 "|                                                         E N T R A D A S                                                          |"
	#define STR0013 "|                                                           S A L I D A S                                                          |"
	#define STR0014 "| CODIFICACION |                    |                                 IPI - VALORES FISCALES                                       |"
	#define STR0015 "|    FISCAL    |  VALORES CONTABLES |    BASE DE CALCULO   |  IMPUESTO ACREDITADO | EXENTAS O NO TRIBUTADAS   |      OTRAS         |"
	#define STR0016 "|    TOTALES   | ################## |  ##################  |  ##################  |    ##################     | ################## |"
	#define STR0017 "| INFORME DE CREDITOS                                                                    |                 VALORES                 |"
	#define STR0018 "|                                                                                        |  COLUMNA AUXILIAR  |        SUMA        |"
	#define STR0019 "| 001 - POR ENTRADAS DEL MERCADO NACIONAL                                                |                    | ################## |"
	#define STR0020 "| 002 - POR ENTRADAS DEL MERCADO EXTERNO                                                 |                    | ################## |"
	#define STR0021 "| 003 - POR SALIDAS PARA EL MERCADO EXTERNO                                              |                    | ################## |"
	#define STR0022 "| 004 - REVERSION DE DEBITOS (DETALLAR A CONTIN.)                                        |                    |                    |"
	#define STR0023 "| 005 - OTROS CREDITOS (DETALLAR A CONTIN.)                                              |                    |                    |"
	#define STR0024 "| 006 - SUBTOTAL                                                                         |                    | ################## |"
	#define STR0025 "| 007 - SALDO ACREEDOR DEL PERIODO ANTERIOR                                              |                    | ################## |"
	#define STR0026 "| 008 - TOTAL                                                                            |                    | ################## |"
	#define STR0027 "| INFORME DE DEBITOS                                                                     |                    |                    |"
	#define STR0028 "| 009 - POR SALIDAS PARA EL MERCADO NACIONAL                                             |                    | ################## |"
	#define STR0029 "| 010 - REVERSION DE CREDITOS (DETALLAR A CONTIN.)                                       |                    |                    |"
	#define STR0030 "| 011 - RESARCIMIENTO DE CREDITOS                                                        |                    | ################## |"
	#define STR0031 "| 012 - OTROS DEBITOS (DETALLAR A CONTIN.)                                               |                    |                    |"
	#define STR0032 "| 013 - TOTAL                                                                            |                    | ################## |"
	#define STR0033 "| CALCULO DEL SALDO                                                                      |                    |                    |"
	#define STR0034 "| 014 - DEBITO TOTAL (=ITEM 013)                                                         |                    | ################## |"
	#define STR0035 "| 015 - CREDITO TOTAL (=ITEM 008)                                                        |                    | ################## |"
	#define STR0036 "| 016 - SALDO DEBEDOR (ITEM 014-ITEM 015)                                                |                    | ################## |"
	#define STR0037 "| 017 - CREDITO TOTAL (ITEM 015-ITEM 014)                                                |                    | ################## |"
	#define STR0038 "| INFORMACION COMPLEMENTARIA                                                                                                       |"
	#define STR0039 "|                         FORMULARIOS DE RECAUDACION                                                                               |"
	#define STR0040 "| NUMERO   FECHA        VALOR               ORGANISMO RECAUDADOR                                                                   |"
	#define STR0041 "| OBSERVACIONES:#################################################################################                                  |"
#else
	#ifdef ENGLISH
		#define STR0001 "IPI Calculation Record"
		#define STR0002 "This program will print the IPI Calculation Tax Record (model P8)"
		#define STR0003 "according to the selected parameters and period."
		#define STR0004 "Z.Form"
		#define STR0005 "Administration"
		#define STR0006 "NO TRANSACTIONS"
		#define STR0007 "|                                                    IPI CALCULATION RECORD                                                       |"
		#define STR0008 "|                                                TAX CALCULATION  STATEMENT                                              |"
		#define STR0009 "| COMP.: #########################################################                                                                 |"
		#define STR0010 "| STA.REGT.: ######################## C.N.P.J.: #################                                                                  |"
		#define STR0011 "| SHEET: ####     MONTH OR PERIOD/YEAR: #######                                                                                      |"
		#define STR0012 "|                                                          I N F L O W S                                                           |"
		#define STR0013 "|                                                           O U T P U T                                                            |"
		#define STR0014 "| CODIFICATION  |                    |                                 IPI - TAX VALUES                                        |"
		#define STR0015 "|    TAX    |  ACCOUNTING VALUES |    CALCULATION BASE   |  CREDITED TAX   | EXEMPT OR NOT TAXED |      OTHERS        |"
		#define STR0016 "|    TOTALS    | ################## |  ##################  |  ##################  |    ##################     | ################## |"
		#define STR0017 "| CREDIT STATEMENT                                                              |                 VALUES              |"
		#define STR0018 "|                                                                                        |   AUXILIAR COLUMN  |        SUM         |"
		#define STR0019 "| 001 - BY INTERNAL MARKET INFLOW                                                        |                    | ################## |"
		#define STR0020 "| 002 - BY EXTERNAL MARKET INFLOW                                                        |                    | ################## |"
		#define STR0021 "| 003 - PER OUTPUT TO INTERNAL MARKET              |                    | ################## |"
		#define STR0022 "| 004 - REVERSAL OF DEBITS (ITEMIZE BELOW)        |                    |                    |"
		#define STR0023 "| 005 - OTHER CREDITS (ITEMIZE BELOW)                                |                    |                    |"
		#define STR0024 "| 006 - SUBTOTAL                                                                         |                    | ################## |"
		#define STR0025 "| 007 - CREDIT BALANCE OF THE PREVIOUS PERIOD                                            |                    | ################## |"
		#define STR0026 "| 008 - TOTAL                                                                            |                    | ################## |"
		#define STR0027 "| DEBIT STATEMENT                                                               |                    |                    |"
		#define STR0028 "| 009 - PER OUTPUT TO NATIONAL MARKET                                               |                    | ################## |"
		#define STR0029 "| 010 - REVERSAL OF CREDITS (ITEMIZE BELOW)                                         |                    |                    |"
		#define STR0030 "| 011 - CREDIT REIMBURSEMENT                                                        |                    | ################## |"
		#define STR0031 "| 012 - OTHER DEBITS (ITEMIZE BELOW)                                              |                    |                    |"
		#define STR0032 "| 013 - TOTAL                                                                            |                    | ################## |"
		#define STR0033 "| BALANCE CALCULATION                                                                |                    |                    |"
		#define STR0034 "| 014 - TOTAL DEBIT (=ITEM 013)                                                          |                    | ################## |"
		#define STR0035 "| 015 - TOTAL CREDIT (=ITEM 008)                                                          |                    | ################## |"
		#define STR0036 "| 016 - DEBIT BALANCE (ITEM 014-ITEM 015)                                                |                    | ################## |"
		#define STR0037 "| 017 - TOTAL CREDIT (ITEM 015-ITEM 014)                                                          |                    | ################## |"
		#define STR0038 "| ADDITIONAL INFORMATION                                                                                                       |"
		#define STR0039 "|                         TAX PAYMENT FORMS                                                                                        |"
		#define STR0040 "| NUMBER   DATE       VALUE             COLLECTING AGENCY                                                                     |"
		#define STR0041 "| NOTES: ##################################################################################                                  |"
	#else
		#define STR0001 "Registro de Apurao de IPI"
		#define STR0002 "Este programa ir imprimir o Livro de Registro de Apurao de IPI (modelo P8)"
		#define STR0003 "conforme parmetros e perodo informados."
		#define STR0004 If( cPaisLoc $ "ANG|PTG", "Cdigo de barras", "Zebrado" )
		#define STR0005 "Administrao"
		#define STR0006 If( cPaisLoc $ "ANG|PTG", "Sem Movimento", "SEM MOVIMENTO" )
		#define STR0007 "|                                                    REGISTRO DE APURAO DO IPI                                                   |"
		#define STR0008 "|                                                DEMONSTRATIVO DE APURAO DO IMPOSTO                                              |"
		#define STR0009 If( cPaisLoc $ "ANG|PTG", "| firma: #########################################################                                                                 |", "| FIRMA: #########################################################                                                                 |" )
		#define STR0010 If( cPaisLoc $ "ANG|PTG", "| insc.est.: ######################## c.n.p.j.: #################                                                                  |", "| INSC.EST.: ######################## C.N.P.J.: #################                                                                  |" )
		#define STR0011 "| FOLHA: ####     MS OU PERODO/ANO: #######                                                                                      |"
		#define STR0012 If( cPaisLoc $ "ANG|PTG", "|                                                         e n t r a d a s                                                          |", "|                                                         E N T R A D A S                                                          |" )
		#define STR0013 "|                                                           S A  D A S                                                            |"
		#define STR0014 "| CODIFICAO  |                    |                                 IPI - VALORES FISCAIS                                        |"
		#define STR0015 "|    FISCAL    |  VALORES CONTBEIS |    BASE DE CALCULO   |  IMPOSTO CREDITADO   | ISENTAS OU NO TRIBUTADAS |      OUTRAS        |"
		#define STR0016 If( cPaisLoc $ "ANG|PTG", "|    totais    | ################## |  ##################  |  ##################  |    ##################     | ################## |", "|    TOTAIS    | ################## |  ##################  |  ##################  |    ##################     | ################## |" )
		#define STR0017 "| DEMONSTRATIVO DE CRDITOS                                                              |                 VALORES                 |"
		#define STR0018 If( cPaisLoc $ "ANG|PTG", "|                                                                                        |   coluna auxiliar  |        soma        |", "|                                                                                        |   COLUNA AUXILIAR  |        SOMA        |" )
		#define STR0019 If( cPaisLoc $ "ANG|PTG", "| 001 - por entradas do mercado nacional                                                 |                    | ################## |", "| 001 - POR ENTRADAS DO MERCADO NACIONAL                                                 |                    | ################## |" )
		#define STR0020 If( cPaisLoc $ "ANG|PTG", "| 002 - por entradas do mercado externo                                                  |                    | ################## |", "| 002 - POR ENTRADAS DO MERCADO EXTERNO                                                  |                    | ################## |" )
		#define STR0021 "| 003 - POR SADAS PARA O MERCADO EXTERNO                                                |                    | ################## |"
		#define STR0022 "| 004 - ESTORNO DE DBITOS (DISCRIMINAR ABAIX0)                                          |                    |                    |"
		#define STR0023 "| 005 - OUTROS CRDITOS (DISCRIMINAR ABAIXO)                                             |                    |                    |"
		#define STR0024 If( cPaisLoc $ "ANG|PTG", "| 006 - subtotal                                                                         |                    | ################## |", "| 006 - SUBTOTAL                                                                         |                    | ################## |" )
		#define STR0025 "| 007 - SALDO CREDOR DO PERODO ANTERIOR                                                 |                    | ################## |"
		#define STR0026 If( cPaisLoc $ "ANG|PTG", "| 008 - total                                                                            |                    | ################## |", "| 008 - TOTAL                                                                            |                    | ################## |" )
		#define STR0027 "| DEMONSTRATIVO DE DBITOS                                                               |                    |                    |"
		#define STR0028 "| 009 - POR SADAS PARA O MERCADO NACIONAL                                               |                    | ################## |"
		#define STR0029 "| 010 - ESTORNO DE CRDITOS (DISCRIMINAR ABAIXO)                                         |                    |                    |"
		#define STR0030 "| 011 - RESSARCIMENTO DE CRDITOS                                                        |                    | ################## |"
		#define STR0031 "| 012 - OUTROS DBITOS (DISCRIMINAR ABAIXO)                                              |                    |                    |"
		#define STR0032 If( cPaisLoc $ "ANG|PTG", "| 013 - total                                                                            |                    | ################## |", "| 013 - TOTAL                                                                            |                    | ################## |" )
		#define STR0033 "| APURAO DO SALDO                                                                      |                    |                    |"
		#define STR0034 "| 014 - DBITO TOTAL (=ITEM 013)                                                         |                    | ################## |"
		#define STR0035 "| 015 - CRDITO TOTAL (=ITEM 008)                                                        |                    | ################## |"
		#define STR0036 If( cPaisLoc $ "ANG|PTG", "| 016 - saldo devedor (item 014-item 015)                                                |                    | ################## |", "| 016 - SALDO DEVEDOR (ITEM 014-ITEM 015)                                                |                    | ################## |" )
		#define STR0037 "| 017 - CRDITO TOTAL (ITEM 015-ITEM 014)                                                |                    | ################## |"
		#define STR0038 "| INFORMAES COMPLEMENTARES                                                                                                       |"
		#define STR0039 If( cPaisLoc $ "ANG|PTG", "|                         guias de recolhimento                                                                                    |", "|                         GUIAS DE RECOLHIMENTO                                                                                    |" )
		#define STR0040 "| NMERO   DATA         VALOR               ORGO ARRECADADOR                                                                      |"
		#define STR0041 "| OBSERVAES: ##################################################################################                                  |"
	#endif
#endif
